checkRequire("Lua_NumberInputItem");
Lua_BatchUseWindow = class("Lua_BatchUseWindow", Lua_Window);
function Lua_BatchUseWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_BatchUseWindow";
	self.skinName = "BatchUseWindow_skin";
	self.isClickClose = true;
end

function Lua_BatchUseWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.img = Lua_ToolImage.new(self.content);
	self.img:setDepth(5);
	self.img:setLocation(0, 74, 0);

	self.numItem = Lua_NumberInputItem.new(self.content);
	self.numItem:setDepth(5);
	self.numItem:setWindowOffset(0, 105);
	self.numItem:setLocation(-44, -28, 0);

	self.subBtn:addClickFuntion(self, self.onSubClick);
	self.cancelBtn:addClickFuntion(self, self.hide);
end

function Lua_BatchUseWindow:showWin(param)
	self.img.data = param.toolData;
	self.itemTxt.text = param.toolData.colorName;

	self.hadCount = 0;
	self.useCount = 0;
	if param.toolData.need_item ~= nil then
		local id = param.toolData.need_item[1]
		self.hadCount = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(id);
		self.hadItemTxt.text = LanUtil.formateStr(LanUtil.getValue(110897), Lua_ToolVo.new(id).colorName .. "x" .. self.hadCount)
		if param.toolData.effect_prop.use_limit_num ~= nil and param.toolData.use_limit_num ~= 0 then
			self.useCount = param.toolData.effect_prop.use_limit_num - param.toolData.useTimes
			self.timesItemTxt.text = LanUtil.formateStr(LanUtil.getValue(110898), tostring(self.useCount), tostring(param.toolData.effect_prop.use_limit_num))
		end
	else
		if param.toolData.effect_prop.use_limit_num ~= nil and param.toolData.use_limit_num ~= 0 then
			self.useCount = param.toolData.effect_prop.use_limit_num - param.toolData.useTimes
			self.timesItemTxt.text = LanUtil.formateStr(LanUtil.getValue(110898), tostring(self.useCount), tostring(param.toolData.effect_prop.use_limit_num));
			self.timesItemTxt:setLocation(60, 112, 0);
		end
	end

	local maxNum = param.maxNum;
	if self.hadCount ~= 0 then
		if maxNum >= self.hadCount then
			maxNum = self.hadCount
		end
	end

	if self.useCount ~= 0 then
		if maxNum >= self.useCount then
			maxNum = self.useCount
		end
	end

	self.owner = param.owner;
	self.callBack = param.callBack;
	self.callBackData = param.callBackData;
	self.numItem:setMinMaxValue(param.minNum == nil and 1 or param.minNum, maxNum);
	self.startMax = param.startMax;
	if self.startMax == true then
		self.numItem:setNum(maxNum);
	else
		self.numItem:setNum(1);
	end
end

function Lua_BatchUseWindow:onSubClick(go)
	if self.callBack ~= nil then
		if self.owner ~= nil then
			self.callBack(self.owner, self.numItem.num, self.callBackData);
		else
			self.callBack(self.numItem.num, self.callBackData);
		end
	end
	self:hide();
end

function Lua_BatchUseWindow:dispose()
	if self.img ~= nil then
		self.img:dispose();
		self.img = nil;
	end
	if self.numItem ~= nil then
		self.numItem:dispose();
		self.numItem = nil;
	end
	self.owner = nil;
	self.callBack = nil;

	self:superCall("dispose");
end