checkRequire("Lua_CombineFourPanel");
checkRequire("Lua_CombineEightPanel");
checkRequire("Lua_CombineListItem");
Lua_CombinePanel = class("Lua_CombinePanel", Lua_DisplayObject);
function Lua_CombinePanel:ctor(p)
	self:superCall("ctor", p, "CombinePanel_skin");
end

function Lua_CombinePanel:buildShowItem()
	self:superCall("buildShowItem");
	
	self.ruleIndex = 140600;

	self:addLuaEvent("OPEN_CLOAK_UPDATE", self, self.updateOpenPael);
	self:addLuaEvent("BAG_COMBINE_REDDOTSTATE_CHANGE", self, self.updateOpenPael);
	self:addLuaEvent("COMBINE_ITEM_SELECTED", self, self.onSelectedCombineItem);
	self:addLuaEvent("ITEM_COMBINE_UPDATE", self, self.onItemCombineUpdate);
	self:addLuaEvent("PACK_UPDATE", self, self.onItemChange);

	self.forCombineItem = Lua_CombineFourPanel.new(self.content);
	self.eightCombineItem = Lua_CombineEightPanel.new(self.content);

	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 310, 585));
	self.dragList:setLocation(343, -34, 0);
	self.dragList:setListCell(Lua_CombineListItem, 115, 310, 1);

	self.btnList = Lua_DragSubButtonList.new(self.content, 1, Vector4(0, -250, 220, 585), nil, nil, nil, Vector2(0, 15));
	self.btnList:setLocation(-496, 222, 0);
	self.btnList:setDepth(5);

	self.xqBtn:addClickFuntion(self, self.onIconClick)
	self.ruleIcon:addClickFuntion(self, self.onRuleIconClick);

	self:updateOpenPael();
	self:updateRedDot();
end

function Lua_CombinePanel:onRuleIconClick()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", nil, LanUtil.getValue(self.ruleIndex));
end

function Lua_CombinePanel:updateOpenPael()
	local arr = DataCenter.combineUtil.combineTitleList;
	self.btnList:setData(arr, self, self.onButtonListClick);
	self.btnList.lastMainSelected = nil;

	if Lua_EquipData.XIANGQIAN_TO_PACK ~= nil and Lua_EquipData.XIANGQIAN_TO_PACK == 2 then
		self.btnList:setMainSlected(2, 1);
		Lua_EquipData.XIANGQIAN_TO_PACK = 1;
	else
		self.Windata = DataCenter.packData.PackWindowData
		local isShenShouData = false;
		if self.Windata ~= nil and type(self.Windata) ~= "number" and self.Windata.ShenShou ~= nil then
			isShenShouData = true;
		end

		if isShenShouData == false then
			if self.isSelect == nil then
				self.isSelect = true;
				self.btnList:setMainSlected(1, 1);
			else
				self.btnList:setMainSlected(DataCenter.combineUtil.selectClass, DataCenter.combineUtil.selectGroup)
			end
		else
			local toIndex = 1;
			for i = 1, arr:getSize() do
				if arr[i].index == 7 then -- 神兽在配置表的位置是7
					toIndex = i;
					break;
				end
			end
			self.btnList:setMainSlected(toIndex, self.Windata.ShenShou);
		end
	end
	self:updateRedDot();
end

function Lua_CombinePanel:onIconClick()
	if DataCenter.funcOpenData:isOpened(10060) == true then
		Lua_WindowUtil.openWin("Lua_PackWindow", WinParam.ACTION_CLOSE);
		Lua_WindowUtil.openWin("Lua_ForgingWindow", WinParam.ACTION_OPEN, {openIdx = 2, nameIndex = 110551});
	else
		local cfg = getConfig({"func_open", 10060});
		if cfg ~= nil and cfg.advance_message ~= nil then
			OperateAlert.show(cfg.advance_message);
		end
	end
end

function Lua_CombinePanel:updateRedDot()
	if self.btnList ~= nil then
		self.btnList:setRedDot(1, DataCenter.combineUtil.combineRedInfo);
		self:updateSubRedDot();
	end
end

function Lua_CombinePanel:updateSubRedDot()
	if self.btnList ~= nil then
		local dic = DataCenter.combineUtil.combineSubRedInfo;
		if self.btnListSelectedData ~= nil and dic ~= nil and dic[self.btnListSelectedData.mainName] ~= nil then
			self.btnList:setRedDot(2, dic[self.btnListSelectedData.mainName]);
		else
			self.btnList:setRedDot(2, {});
		end
	end
end

function Lua_CombinePanel:onItemChange(msg)
	self:selectCellData(self.selectedData);
	self:updateRedDot();
end

function Lua_CombinePanel:onItemCombineUpdate(msg)
	self:selectCellData(self.selectedData);
	if msg.is_success == 1 then
		self:showEffect(1);
	else
		self:showEffect(2);
	end
end

function Lua_CombinePanel:selectCellData(val)
	self.selectedData = val;
	for i = 1, self.combineList:getSize() do
		self.combineList[i].selected = self.combineList[i].id == val.id;
		self.combineList[i].selectIndex = i;
	end

	self.dragList:setLuaArrayData(self.combineList, false);
	if self.combineList:getSize() * 115 <= 585 then
		self.dragList:moveToIndex(1, true);
	end

	if val ~= nil then
		if val.rateCount == 0 then
			self.forCombineItem:setEnable(true);
			self.eightCombineItem:setEnable(false);
			self.forCombineItem:setData(val);
		else
			self.forCombineItem:setEnable(false);
			self.eightCombineItem:setEnable(true);
			self.eightCombineItem:setData(val);
		end
	end
end

function Lua_CombinePanel:onButtonListClick(val)
	DataCenter.combineUtil.selectCombineId = val.data;
	-- 记录选择组ID207100101
	self:setShowType(val.data);
	self.btnListSelectedData = val;
	self:updateSubRedDot();
	self.xiangQianObj:SetActive(val.mainIndex == 2);

	if val.mainName == "高級精靈" or val.mainName == "囚屍裝備" then
		self.ruleIcon:setEnable(true)
		if val.mainName == "高級精靈" then
			self.ruleIndex = 140600
		elseif val.mainName == "囚屍裝備" then
			self.ruleIndex = 120595
		end
	else
		self.ruleIcon:setEnable(false)
	end
end

-- 1成功, 2失败
function Lua_CombinePanel:showEffect(val)
	if self.rsEffect ~= nil then
		self.rsEffect:dispose();
		self.rsEffect = nil;
	end

	if val == 1 then
		self.rsEffect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_hechengchenggong", "gui_hechengchenggong", -90, 35);
	else
		self.rsEffect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_hechengshibai", "gui_hechengshibai", -90, 35);
	end
	self.rsEffect:SetRenderQueue(self.infoBg, 100, 2, false);
end

function Lua_CombinePanel:setShowType(val)
	self.selectedType = val;
	self.combineList = DataCenter.combineUtil:getCombineListById(val);
	if self.defaultSelectVo ~= nil then
		self:onSelectedCombineItem(self.defaultSelectVo);
		self.defaultSelectVo = nil;
	else
		if self.selectIndex ~= DataCenter.combineUtil.selectCombineId then
			self:onSelectedCombineItem(self.combineList[1]);
			DataCenter.combineUtil.selectIndex = nil;
		else
			if DataCenter.combineUtil.selectIndex == nil then
				self:onSelectedCombineItem(self.combineList[1]);
			else
				self:onSelectedCombineItem(self.combineList[DataCenter.combineUtil.selectIndex]);
			end
		end
		self.selectIndex = DataCenter.combineUtil.selectCombineId;
	end
end

function Lua_CombinePanel:onSelectedCombineItem(val)
	self:selectCellData(val);
end

-- 默认显示信息
function Lua_CombinePanel:showDefaultData(data)
	self.defaultSelectVo = nil;
	if data ~= nil then
		local dic = DataCenter.combineUtil.combineAllInfo;
		if dic ~= nil then
			for k, v in pairs(dic) do
				for i = 1, v:getSize() do
					local vo = v[i];
					local arr = vo.materials;
					if arr ~= nil then
						for j = 1, arr:getSize() do
							if arr[j].id == data.id then
								local list = DataCenter.combineUtil.combineTitleList;
								for n = 1, list:getSize() do
									local obj = list[n];
									if obj.data == vo.type then
										self.defaultSelectVo = vo;
										self.btnList:setMainSlected(n, 1);
										return;
									elseif obj.sub ~= nil then
										local subArr = obj.sub;
										for m = 1, subArr:getSize() do
											if subArr[m].data == vo.type then
												self.defaultSelectVo = vo;
												self.btnList:setMainSlected(n, m);
												return;
											end
										end
									end
								end
								return;
							end
						end
					end
				end
			end
		end
	end
end

function Lua_CombinePanel:dispose()
	if self.forCombineItem ~= nil then
		self.forCombineItem:dispose();
		self.forCombineItem = nil;
	end
	if self.eightCombineItem ~= nil then
		self.eightCombineItem:dispose();
		self.eightCombineItem = nil;
	end
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.rsEffect ~= nil then
		self.rsEffect:dispose();
		self.rsEffect = nil;
	end
	DataCenter.packData.PackWindowData = nil;
	self.Windata = nil;

	self:superCall("dispose");
end