Lua_ItemSelectedWindow = class("Lua_ItemSelectedWindow", Lua_Window);
function Lua_ItemSelectedWindow:ctor()
	self:superCall("ctor");
	
	self.windowName = "Lua_ItemSelectedWindow";
	self.skinName = "ItemSelectedWindow_skin";
	self.isClickClose = true;
	self.blackAlpha = 0.5;
end

function Lua_ItemSelectedWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.itemDragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 380, 432));
	self.itemDragList:setLocation(0, -35, 0);
	self.itemDragList:setListCell(Lua_ItemSelectedItem, 126, 380, 1);
end

function Lua_ItemSelectedWindow:showWin(param)
	self:superCall("showWin", param);

	local arr = Array();
	if param.isEquip == nil or param.isEquip then -- 装备选择
	 	local list = param.list;
		for i = 1, list:getSize() do
			list[i].moutEquItemIndex = param.index;
			arr:add({data = list[i], isEquip = param.isEquip, isEquipPart = param.isEquipPart})
		end
		self.titleTxt.text = LanUtil.getValue(110750);
	else -- 道具选择
		local rateItems = param.data.rateItem;
		if param.isSameItemId ~= nil and param.isSameItemId then -- 注：添加isSameItemId字段为True，当点击添加道具是同一个ID时，特殊处理，
			arr:add({index = param.index, id = rateItems[1].itemId, addItems = param.list,
				success = param.success, maxSucRate = param.maxSucRate, isEquip = param.isEquip});
		else
			local numDic = {};
			for k,v in pairs(param.list) do
				if numDic[v] == nil then
					numDic[v] = 0;
				end
				numDic[v] = numDic[v] + 1;
			end

			local useNum;
			local hasNum;
			local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
			for i = 1, rateItems:getSize() do
				useNum = numDic[rateItems[i].itemId] == nil and 0 or numDic[rateItems[i].itemId];
				hasNum = bagData:getItemNum(rateItems[i].itemId);
				if hasNum > useNum then
					arr:add({index = param.index, id = rateItems[i].itemId, addItems = param.list,
						success = param.success, maxSucRate = param.maxSucRate, isEquip = param.isEquip});
				end
			end
		end
		self.titleTxt.text = LanUtil.getValue(110751);
	end
	self.itemDragList:setLuaArrayData(arr, false);
end

function Lua_ItemSelectedWindow:dispose()
	if self.itemDragList ~= nil then
		self.itemDragList:dispose();
		self.itemDragList = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_ItemSelectedItem = class("Lua_ItemSelectedItem", Lua_ListCell);
function Lua_ItemSelectedItem:ctor(p)
	self:superCall("ctor", p, "ItemSelectedItem_skin");
end

function Lua_ItemSelectedItem:buildShowItem()
	self:superCall("buildShowItem");
	
	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(5);
	self.itemImg:setLocation(-132, 2, 0);
end

function Lua_ItemSelectedItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local tvo;
	if data.isEquip == true then
		tvo = Lua_ToolVo.createToolVo(data.data.id, data.data.amount, data.data.bind);
		tvo.isShowBtn = false;
		tvo.equipment = data.data.equipment;
		tvo.packType = Lua_PackData.BAG_PACK;
	elseif data.isEquip == false then
		tvo = Lua_ToolVo.createToolVo(data.id);
	end
	self.itemImg.data = tvo;

	self.itemTxt.text = tvo.colorName;
end

function Lua_ItemSelectedItem:onPlayerSoundClick(go)
	if self._data.isEquipPart ~= nil and self._data.isEquipPart then -- 骑装栏打开装备选择
		Lua_ProxyManager.getProxy("Lua_MountProxy"):sApparelMountEquip(self._data.data.index);
		Lua_WindowUtil.openWin("Lua_ItemSelectedWindow", WinParam.ACTION_CLOSE);
		return
	end

	if self._data.isEquip == true then -- 装备选择
		Lua_MsgUtil.callFunc("NEED_ITEM_SELECTED", {index = self._data.data.moutEquItemIndex, data = self._data.data});
	elseif self._data.isEquip == false then -- 道具选择
		if self._data.success ~= nil and self._data.success == self._data.maxSucRate then
			OperateAlert.show(LanUtil.getValue(110735));
			return
		end
		local bagNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(self._data.id);
		local tvo = Lua_ToolVo.createToolVo(self._data.id);
		local outNum = 0;
		for i = 1, 3 do
			if self._data.addItems[i] == self._data.id then
				outNum = outNum + 1;
			end
		end

		if bagNum <= outNum then
			OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(110829), tvo.colorName));
		else
			Lua_MsgUtil.callFunc("RATE_ITEM_SELECTED", {index = self._data.index, itemId = self._data.id});
		end
	end
	Lua_WindowUtil.openWin("Lua_ItemSelectedWindow", WinParam.ACTION_CLOSE);
end

function Lua_ItemSelectedItem:dispose()
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end