Lua_PackHeChengWindow = class("Lua_PackHeChengWindow", Lua_Window);
function Lua_PackHeChengWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_PackHeChengWindow";
	self.skinName = "TiHuan_skin";
end

function Lua_PackHeChengWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.titleNameLab.text = LanUtil.getValue(120535);

	self.tihuanBtn:setEnable(false);
	self.xiexiaBtn:setEnable(false);

	self.tihuan_DragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 380, 432));
	self.tihuan_DragList:setLocation(0, -35, 0);
	self.tihuan_DragList:setListCell(Lua_PackTiHuanEquItem, 126, 380, 1);
end

function Lua_PackHeChengWindow:showWin(param)
	local indexArr = param.indexArr;
	local bagData = DataCenter.packData:getBagType(Lua_PackData.SACRED_ANIMAL_BAG);
	local _arr = bagData:getBagAllData();
	local arr = Array();
	for i = 1, _arr:getSize() do
		if _arr[i].subType == Lua_PackTypeDefine.SHENSHOU_EQU and _arr[i].color == param.color and _arr[i].star == param.star then
			if indexArr:indexOf(_arr[i].index) == -1 then
				arr:add(_arr[i]);
			end
		end
	end
	arr:sort("index", false)
	self.tihuan_DragList:setLuaArrayData(arr, false);
end

function Lua_PackHeChengWindow:dispose()
	if self.tihuan_DragList ~= nil then
		self.tihuan_DragList:dispose();
		self.tihuan_DragList = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_PackTiHuanEquItem = class("Lua_PackTiHuanEquItem", Lua_ListCell);
function Lua_PackTiHuanEquItem:ctor(p)
	self:superCall("ctor", p, "TiHuanEquipItem_skin");
end

function Lua_PackTiHuanEquItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg.isShowBtns = false;
	self.itemImg:setDepth(5);
	self.itemImg:setCanClick(true);
	self.itemImg:setLocation(-132, 2, 0);
end

function Lua_PackTiHuanEquItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.itemImg.data = data;
	self.itemNameTxt.text = self.itemImg.data.colorName;
end

function Lua_PackTiHuanEquItem:onPlayerSoundClick(go)
	Lua_MsgUtil.callFunc("PACK_HECHENG_PUINTO_EQUIP", self._data);
	Lua_WindowUtil.openWin("Lua_PackHeChengWindow", WinParam.ACTION_CLOSE)
end

function Lua_PackTiHuanEquItem:dispose()
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end