checkRequire("Lua_PackItemListContainer");
checkRequire("Lua_BatchSalePanel");
checkRequire("Lua_PackLeftPanel");
Lua_PackPanel = class("Lua_PackPanel", Lua_DisplayObject);
function Lua_PackPanel:ctor(p)
	self:superCall("ctor", p, "PackPanel_skin", true);
end

function Lua_PackPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.showModel = true;
	self.saleShow = false;
	DataCenter.packData.showSalePanel = false;

	local packPage = Lua_CommonUtil.getCommonConfig("bag_pack_page", 1);
	self.leftPackItem = Lua_PackItemListContainer.new(self.content, Lua_PackData.BAG_PACK, 0, -246, packPage);
	self.leftPackItem:setLocation(272, 26, 0);

	self.leftPanel = Lua_PackLeftPanel.new(self.content);
	self.leftPanel:setLocation(-306, 10, 0);

	self.soleBtn:addClickFuntion(self, self.onSaleClick);
	self.zhengliBtn:addClickFuntion(self, self.onZhengLiClick);

	self:addLuaEvent("PACK_UPDATE", self, self.onPackUpdate);
	self:addLuaEvent("SHOW_HIDE_SALE_ITEM", self, self.setSaleShow);
	self:addLuaEvent("USE_PACK_GIFT", self, self.onUsePackGift)
	sendMsg(11403817); -- 获取穿戴神翼信息
end

function Lua_PackPanel:onPackUpdate(packType)
	if packType == Lua_PackData.BAG_PACK then
		self.leftPackItem:updateData();
	end
end

function Lua_PackPanel:setSaleShow(val)
	self.saleShow = val;
	if self.saleShow == true then
		if self.saleObj == nil then
			self.saleObj = Lua_BatchSalePanel.new(self.content);
		end
		self.saleObj:setEnable(true);
		self.soleBtn.label = LanUtil.getValue(10016);
	else
		if self.saleObj ~= nil then
			self.saleObj:setEnable(false);
		end
		self.soleBtn.label = LanUtil.getValue(110837);
	end

	self.leftPanel:setEnable(not val);
	DataCenter.packData.showSalePanel = self.saleShow;
	Lua_MsgUtil.callFunc("UPDATE_SALE_ITEM");
	LuaUtil.updateWindowDepth(nil);
end

function Lua_PackPanel:onUsePackGift(data)
	self.data = data;

	local tvo = Lua_ToolVo.new(data.need_money[1], data.need_money[2]);
	if self.amount == nil then
		self.amount = 1;
	end
	self.totalMoney = data.need_money[2] * self.amount;
	self.moneyType = data.need_money[1];

	local tipData = {};
	tipData.owner = self;
	tipData.des = LanUtil.formateStr(LanUtil.getValue(123802), tostring(self.totalMoney), tvo.name);
	tipData.rewardArr = Lua_RewardsUtil.getRewardList(self.data.effect_prop.reward_id).rewardsVoArr;
	tipData.type = 1;
	tipData.subFun = self.onEnSureClickCallBack;
	-- tipData.cancelFun = self.onSubClick; -- 取消
	Lua_WindowUtil.openWin("Lua_TipsWindow", WinParam.ACTION_OPEN, tipData);
end

function Lua_PackPanel:onEnSureClickCallBack(data)
	DataCenter.moneyData:isMoneyEnough(self.moneyType, self.totalMoney, false, true);
	local msg = ProtoPublic_pb.Proto11400106();
	msg.index = self.data.index;
	if self.amount ~= nil then
		msg.amount = self.amount;
	else
		msg.amount = 1;
	end

	if self.reward_index ~= nil then
		msg.reward_index = self.reward_index
	end
	sendMsg(11400106, msg);
end

function Lua_PackPanel:onSaleClick(go)
	self:setSaleShow(not self.saleShow);
end

function Lua_PackPanel:onZhengLiClick(go)
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	bagData:reoder();
	Lua_MsgUtil.callFunc("PACK_ZHENGLI");
end

function Lua_PackPanel:dispose()
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	bagData:clearSaleList();
	DataCenter.packData.showSalePanel = false;

	self:superCall("dispose");
end