Lua_PackUnlockWindow = class("Lua_PackUnlockWindow", Lua_Window);
function Lua_PackUnlockWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_PackUnlockWindow";
	self.skinName = "PackUnlockWindow_skin";
end

function Lua_PackUnlockWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(5);
	self.itemImg:setLocation(59.5, 32.5, 0);

	self.subBtn:addClickFuntion(self, self.onSubClick);
end

function Lua_PackUnlockWindow:showWin(param)
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	self.unlockNum = 0;
	if type(param) == "table" then
		if 6 * 25 - bagData.packSize > 0 then
			self.unlockNum = 1;
		else
			OperateAlert.show(LanUtil.getValue(110884));
			self:hide();
			return;
		end
	elseif type(param) == "number" then
		self.unlockNum = tonumber(param);
	end
	self.lockNumTxt.text = tostring(self.unlockNum);

	local defaultSize = getConfig({"packageConfig", "package_min_size"});
	local itemCostNums = getConfig({"packageConfig", "unlock_config", "need_goods_number"});
	local allNum = 0;
	local startIndex = bagData.packSize - defaultSize;
	for i = 1, self.unlockNum do
		if itemCostNums[startIndex + i] ~= nil then
			allNum = allNum + itemCostNums[startIndex + i];
		end
	end

	local itemId = getConfig({"packageConfig", "unlock_config", "goods_id"});
	self.itemNeedNum = bagData:getItemNum(itemId);
	self.itemImg.data = Lua_ToolVo.createToolVo(itemId, 0, 0);
	self.itemImg:showNumLimit(self.itemNeedNum, allNum, 2);

	local costNum = allNum - self.itemNeedNum;
	local perCostGold = getConfig({"packageConfig", "unlock_config", "goods_correspond_gold"});
	if costNum > 0 then
		self.costGold = perCostGold * costNum;
		if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD_AND_BINDGOLD, self.costGold, false, false) == false then
			self.costTxt.text = "["..Lua_ColorDefine.RED_STR.."]"..tostring(self.costGold).."[-]";
		else
			self.costTxt.text = "["..Lua_ColorDefine.GREEN_STR.."]"..tostring(self.costGold).."[-]";
		end
	else
		self.costGold = 0;
		self.costTxt.text = "["..Lua_ColorDefine.GREEN_STR.."]0[-]";
	end
end

function Lua_PackUnlockWindow:onSubClick(go)
	if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD_AND_BINDGOLD, self.costGold, true, true) == false then
		return;
	end

	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	local itemId = getConfig({"packageConfig", "unlock_config", "goods_id"});
	local tvo = Lua_ToolVo.new(itemId);
	local num = bagData:getItemNum(itemId);
	if num < self.itemNeedNum then
		OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(110829), tvo.colorName));
		return;
	end

	if self.costGold > 0 then
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, type = 1, subFun = self.onSubCallback,
			des = LanUtil.formateStr(LanUtil.getValue(110860), tostring(self.costGold))});
	else
		local cmd = ProtoPublic_pb.Proto11400103();
		cmd.pack_type = Lua_PackData.BAG_PACK;
		cmd.index = bagData.packSize + self.unlockNum;
		sendMsg(11400103, cmd);

		self:hide();
	end
end

function Lua_PackUnlockWindow:onSubCallback(o)
	if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD_AND_BINDGOLD, self.costGold, true, true) == false then
		return;
	end

	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	local cmd = ProtoPublic_pb.Proto11400103();
	cmd.pack_type = Lua_PackData.BAG_PACK;
	cmd.index = bagData.packSize + self.unlockNum;
	cmd.is_gold = 1;
	sendMsg(11400103, cmd);

	self:hide();
end