checkRequire("Lua_WhareCellsItem");
checkRequire("Lua_PackItemListContainer");
Lua_WharehousePanel = class("Lua_WharehousePanel", Lua_DisplayObject);
function Lua_WharehousePanel:ctor(p)
	self:superCall("ctor", p, "WharehousePanel_skin");
	self.showModel = true;
end
function Lua_WharehousePanel:buildShowItem()
	self:superCall("buildShowItem");

    local packPage = Lua_CommonUtil.getCommonConfig("bag_pack_page", 1);
	self.rightPackItem = Lua_PackItemListContainer.new(self.content, Lua_PackData.BAG_PACK, 0, -243, packPage);
	self.rightPackItem:setLocation(240, 0, 0);

    local wharePage = Lua_CommonUtil.getCommonConfig("whare_pack_page", 1);
	self.leftPackItem = Lua_PackItemListContainer.new(self.content, Lua_PackData.WHARE, 0, -243, wharePage);
	self.leftPackItem:setLocation(-320, 0, 0);

	self.leftBtn:addClickFuntion(self, self.onLeftClick);
	self.allBtn:addClickFuntion(self, self.onAllClick);
	self.rightBtn:addClickFuntion(self, self.onRightClick);

    self.infoTxt.text = LanUtil.getValue(110803);

    DataCenter.packData.showWharePanel = true;

    self:addLuaEvent("PACK_UPDATE", self, self.onPackUpdate);
end
function Lua_WharehousePanel:dispose()
	self:superCall("dispose");
	DataCenter.packData.showWharePanel = false;
end
function Lua_WharehousePanel:onPackUpdate(o)
	if o == Lua_PackData.WHARE then
		self.leftPackItem:updateData();
	elseif o == Lua_PackData.BAG_PACK then
		self.rightPackItem:updateData();
	end
end
function Lua_WharehousePanel:onLeftClick(o)
	local bagData = DataCenter.packData:getBagType(Lua_PackData.WHARE);
    bagData:reoder();
end
function Lua_WharehousePanel:onAllClick(o)
	self:onLeftClick();
	self:onRightClick();
end
function Lua_WharehousePanel:onRightClick(o)
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
    bagData:reoder();
end