﻿
Lua_EquipDuanHunPanel = class("Lua_EquipDuanHunPanel", Lua_DisplayObject);
function Lua_EquipDuanHunPanel:ctor(p)
    self:superCall("ctor", p, "DuanHunPanel_skin");

end
function Lua_EquipDuanHunPanel:buildShowItem()
    self:superCall("buildShowItem");
    self:addLuaEvent("UPDATE_FUHUNPANEL_INFO", self, self.onUpdateInfo)
    self.ItemArr = Array()
    self.ItemList = Array()
    self.iconArr = Array()
    self.txtArr = Array()
    self.ObjList = Array()

    self.effect = UICreate.createUIEffect(self.content, nil, nil, 0, 0);
    self.effect:setSacle(1, 1, 1);
    self.effect:SetRenderQueue(self.txt3, 5, 2,false);
    self.effect:setLocation(-250, 0)
    self.effect:setEnable(true)

    self.selectedIndex = 1
    self.selectedHunYuIndex = 0
    self.isFirst = true
    self.helpIcon:addClickFuntion(self, self.onHelpClick)
    self.fuhunBtn:addClickFuntion(self, self.onFuHunClick)
    self.redDot = UICreate.createUIAtlasImage(self.fuhunBtn.mainContent, "iconantlas4", "redDot", 60, 16, 0, 0)
    self.redDot:setDepth(9);
    self.redDot.clickScale = false;
    self.redDot.name = "redDot"
    self.redDot:setEnable(false);
    Lua_ProxyManager.getProxy("Lua_FuHunProxy"):sInitMsg()
end 
function Lua_EquipDuanHunPanel:onCreateItem(x, y, index)
    for i = 1, 6 do
        local equipdata = DataCenter.fuHunData:getFuHunInfoByPart(i + index)
        local part = i + index
        if self.ItemArr[part] == nil then
            local timg = Lua_ToolImage.new(self.content);
            timg:setDepth(6);
            local posY = y - 85 *(i - 1)
            if index == 6 then
                posY = y + 85 *(i - 1)
            end
            timg:setLocation(x, posY);
            timg.content.name = part;
            timg:setDefaultIcon("fuhunWindow", equipdata.duanhun_icon);
            timg:setScale(0.9, 0.9)
            timg:showDefaultIcon(true)
            timg:removeFun(false)
            timg.item_bg:addClickFuntion(self, self.onIconClick);
            timg:setGray(not equipdata.is_activate)

            local label = UICreate.createLabel(timg.item_bg.mainContent, nil, -36, 25, 71, 22, 22);
            label.overflowMethod = UILabel.Overflow.ResizeFreely;
            label.effectStyle = 3;
            label.effectColorStr = Lua_ColorDefine.transColor("192e41");
            label.pivot = UIWidget.Pivot.Left;
            label:setDepth(9);
            if equipdata.soul_jade_total == 0 then
                label.text = ""
            else
                label.text = "+" .. equipdata.soul_jade_total
            end
            local effect = UICreate.createUIEffect(timg.mainContent, "/effects/scsEffects/" .. equipdata.duanhun_icon_effect, equipdata.duanhun_icon_effect, 0, 0);
            effect:setSacle(1, 1, 1);
            effect:SetRenderQueue(self.txt3, 5, 2);
            effect:setEnable(equipdata.is_activate)

            local selected_mask = UICreate.createUIAtlasImage(timg.item_bg.mainContent, "forgingWindow", "item_selected", 0, 0, 94, 94);
            selected_mask:setDepth(8);
            selected_mask:setEnable(false)

            local redDot = UICreate.createUIAtlasImage(timg.item_bg.mainContent, "iconantlas4", "redDot", 28, 28, 0, 0)
            redDot:setDepth(9);
            redDot.clickScale = false;
            redDot.name = "redDot"
            redDot:setEnable(equipdata.redDotState);

            local list = { }
            list.item = timg
            list.selected_mask = selected_mask
            list.redDot = redDot
            list.label = label
            list.effect = effect
            list.index = part
            self.ItemArr:add(list);
        else
            if equipdata.soul_jade_total == 0 then
                self.ItemArr[part].label.text = ""
            else
                self.ItemArr[part].label.text = "+" .. equipdata.soul_jade_total
            end
            self.ItemArr[part].redDot:setEnable(equipdata.redDotState);
            self.ItemArr[part].effect:setEnable(equipdata.is_activate)
            self.ItemArr[part].item:setGray(not equipdata.is_activate)
        end
    end
end
function Lua_EquipDuanHunPanel:onHelpClick()
    Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(141303));
end

function Lua_EquipDuanHunPanel:onFuHunClick()
    if self.data == nil then
        return
    end
    if self.data.is_activate == false then
        Lua_ProxyManager.getProxy("Lua_FuHunProxy"):sZhuHunMsg(self.selectedIndex)
    else
        Lua_ProxyManager.getProxy("Lua_FuHunProxy"):sLvlUpMsg(self.selectedIndex, self.selectedHunYuIndex)
    end
end

function Lua_EquipDuanHunPanel:onUpdateInfo()
    self:onCreateItem(-555, 150, 0)
    self:onCreateItem(55, -275, 6)
    self:onSelectedByIndex(self.selectedIndex)
end

function Lua_EquipDuanHunPanel:onIconClick(go)
    local index = tonumber(go.transform.parent.name)
    self:onSelectedByIndex(index)
end
function Lua_EquipDuanHunPanel:onSelectedByIndex(value)
    if self.selectedIndex ~= value then
        self.selectedHunYuIndex = 0
        self.isFirst = true
    end
    self.selectedIndex = value

    self.data = DataCenter.fuHunData:getFuHunInfoByPart(self.selectedIndex)
    local len = self.ItemArr:getSize()
    for i = 1, len do
        if self.ItemArr[i].index == self.selectedIndex then
            if self.ItemArr[i].selected_mask ~= nil then
                self.ItemArr[i].selected_mask:setEnable(true);
            end
            self.selectedIndex = self.ItemArr[i].index
        else
            if self.ItemArr[i].selected_mask ~= nil then
                self.ItemArr[i].selected_mask:setEnable(false);
            end
        end
    end
    self:showCostItem()
    self:showIconItem()
    self:showItemInfo()
    self.txt3.text = self.data.name
    self.effect:setUrl("/effects/scsEffects/" .. self.data.duanhun_show_effect, self.data.duanhun_show_effect)
    if self.data.is_activate == false then
        self.fuhunBtn.label = LanUtil.getValue(141312)
    else
        self.fuhunBtn.label = LanUtil.getValue(141313)
    end
end 

function Lua_EquipDuanHunPanel:getHunYuCost()
    local arr = Array()
    local configData = DataCenter.fuHunData.equipHunYuConfig[self.selectedIndex * 10000 + self.selectedHunYuIndex]["cost"][self.data.HunYuVoArr[self.selectedHunYuIndex + 1].hunYuLvl + 1]
    if configData == nil then
        return arr
    end
    local len = #configData
    for i = 1, len do
        local itemVo = Lua_ToolVo.new(configData[i][1], configData[i][2])
        arr:add(itemVo)
    end
    return arr
end

function Lua_EquipDuanHunPanel:showCostItem()
    local costItemList = self.data.CostItem;
    if self.data.is_activate == true then
        costItemList = self:getHunYuCost()
    end
    local len = 0
    if costItemList ~= nil then
        len = costItemList:getSize()
    end
    self.costItemId = 0
    local startX = -120
    local objLen = self.ItemList:getSize();
    for i = 1, objLen do
        self.ItemList[i]:dispose()
    end
    self.ItemList:clear()
    for i = 1, len do
        local item = Lua_ToolImage.new(self.fengexian.mainContent);
        item:setDepth(7);
        item:setLocation(startX +(i - 1) * 90, -80, 0);
        item.data = costItemList[i]
        item.content.name = i
        local hadCount = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(costItemList[i].id);
        item:showNumLimit(hadCount, costItemList[i].count, 2)
        if hadCount < costItemList[i].count then
            self.costItemId = costItemList[i].id
        end
        self.ItemList:add(item)
    end
end

function Lua_EquipDuanHunPanel:showIconItem()
    local voArr = self.data.HunYuVoArr;
    local len = voArr:getSize()
    local objLen = self.iconArr:getSize();
    for i = 1, objLen do
        self.iconArr[i].icon:dispose()
        self.iconArr[i].label:dispose()
        self.iconArr[i].selected_mask:dispose()
        self.iconArr[i].redDot:dispose()
    end
    self.iconArr:clear()
    for i = 1, len do
        local icon = UICreate.createUIAtlasImage(self.content, "packWindow", voArr[i].iconName, 0, 0, 0, 0);
        icon:setDepth(8);
        icon:setLocation(self.iconPosList[i].x, self.iconPosList[i].y)
        icon.mainContent.name = i - 1
        icon.clickScale = false
        icon:addClickFuntion(self, self.onHunYuIconClick)
        local label = UICreate.createLabel(self.content, nil, self.iconPosList[i].x, self.iconPosList[i].y - 50, 71, 22, 22);
        label.overflowMethod = UILabel.Overflow.ResizeFreely;
        label.effectStyle = 3;
        label.effectColorStr = Lua_ColorDefine.transColor("192e41");
        label.pivot = UIWidget.Pivot.Center;
        label:setDepth(8);
        label.text = "Lv." .. voArr[i].hunYuLvl

        local selected_mask = UICreate.createUIAtlasImage(icon.mainContent, "armySoul", "select", 0, 0, 84, 84);
        selected_mask:setDepth(9);
        selected_mask:setEnable(false)

        local redDot = UICreate.createUIAtlasImage(icon.mainContent, "iconantlas4", "redDot", 25, 20, 0, 0)
        redDot:setDepth(10);
        redDot.clickScale = false;
        redDot.name = "redDot"
        redDot:setEnable(voArr[i].hunYuRedDot);

        local list = { }
        list.label = label
        list.icon = icon
        list.index = i - 1
        list.selected_mask = selected_mask
        list.redDot = redDot
        self.iconArr:add(list)
    end
    self:onSelectedHunYuByIndex(self.selectedHunYuIndex)

end
function Lua_EquipDuanHunPanel:onHunYuIconClick(go)
    local index = tonumber(go.name)
    self.isFirst = false
    self:onSelectedHunYuByIndex(index)
end

function Lua_EquipDuanHunPanel:onSelectedHunYuByIndex(value)
    if self.data.redDotState == true then
        self.redDot:setEnable(true)
    else
        self.redDot:setEnable(self.data.HunYuVoArr[self.selectedHunYuIndex + 1].hunYuRedDot)
    end

    if self.data.HunYuVoArr[value + 1].is_open == false then
        if self.isFirst == false then
            OperateAlert.show(DataCenter.fuHunData.equipHunYuConfig[self.selectedIndex * 10000 + value].description);
        end
        if self.selectedHunYuIndex == 0 then
            self:showAddValueInfo()
        end
        return
    end
    self.selectedHunYuIndex = value
    local len = self.iconArr:getSize()
    for i = 1, len do
        if self.iconArr[i].index == self.selectedHunYuIndex then
            if self.iconArr[i].selected_mask ~= nil then
                self.iconArr[i].selected_mask:setEnable(true);
            end
            self.selectedHunYuIndex = self.iconArr[i].index
        else
            if self.iconArr[i].selected_mask ~= nil then
                self.iconArr[i].selected_mask:setEnable(false);
            end
        end
    end
    self:showAddValueInfo()
    self:showCostItem()
end

function Lua_EquipDuanHunPanel:showItemInfo()
    local attrArr = self.data.txtInfoShow
    local len = attrArr:getSize()
    local objLen = self.txtArr:getSize();
    for i = 1, objLen do
        self.txtArr[i].text = ""
    end
    for i = 1, len do
        if self.txtArr[i] == nil then
            local label = UICreate.createLabel(self.content, nil, 155, 150 -(i - 1) * 35, 71, 22, 24);
            label.overflowMethod = UILabel.Overflow.ResizeFreely;
            label.pivot = UIWidget.Pivot.Left;
            label:setDepth(6);
            label.text = attrArr[i]
            self.txtArr:add(label)
        else
            self.txtArr[i].text = attrArr[i]
        end
    end
end 

function Lua_EquipDuanHunPanel:getToTalValue()
    local attrArr = self.data.baseAttr
    local len = self.data.baseAttr:getSize()
    local hunYuVoArr = self.data.HunYuVoArr;
    local len2 = hunYuVoArr:getSize()
    local attrList = { }
    local arr = Array()
    for i = 1, len2 do
        local typeIndex = i - 1
        if hunYuVoArr[i].hunYuLvl ~= 0 then
            local configData = DataCenter.fuHunData.equipHunYuConfig[self.selectedIndex * 10000 + typeIndex]
            for c = 1, len do
                if attrList[attrArr[c].attr] == nil then
                    attrList[attrArr[c].attr] = configData[attrArr[c].attr][hunYuVoArr[i].hunYuLvl]
                else
                    attrList[attrArr[c].attr] = attrList[attrArr[c].attr] + configData[attrArr[c].attr][hunYuVoArr[i].hunYuLvl]
                end
            end
        end
    end
    for i = 1, len do
        local list = { }
        list.attrName = attrArr[i].attrName
        list.value = attrArr[i].value
        if attrList[attrArr[i].attr] ~= nil then
            list.value = attrArr[i].value + attrList[attrArr[i].attr];
        end
        list.attr = attrArr[i].attr
        arr:add(list)
    end
    return arr
end

function Lua_EquipDuanHunPanel:showAddValueInfo()
    -- local attrArr = self.data.baseAttr
    local len = self.data.baseAttr:getSize()
    local attrArr = self:getToTalValue()
    local arr = Array()
    self.state = false
    local configData = DataCenter.fuHunData.equipHunYuConfig[self.selectedIndex * 10000 + self.selectedHunYuIndex];
    for i = 1, len do
        local list = { }
        list.value = attrArr[i].value
        list.attrName = attrArr[i].attrName
        if self.data.HunYuVoArr[self.selectedHunYuIndex + 1].hunYuLvl == 0 then
            list.addValue = configData[attrArr[i].attr][1]
        else
            if configData[attrArr[i].attr][self.data.HunYuVoArr[self.selectedHunYuIndex + 1].hunYuLvl + 1] ~= nil then
                list.addValue = configData[attrArr[i].attr][self.data.HunYuVoArr[self.selectedHunYuIndex + 1].hunYuLvl + 1] - configData[attrArr[i].attr][self.data.HunYuVoArr[self.selectedHunYuIndex + 1].hunYuLvl]
            else
                list.addValue = 0
                self.state = true
            end
            --  list.value = list.value + configData[attrArr[i].attr][self.data.HunYuVoArr[self.selectedHunYuIndex + 1].hunYuLvl]
        end
        arr:add(list)
    end
    if self.data.HunYuVoArr[self.selectedHunYuIndex + 1].is_open == false then
        for i = 1, len do
            local tempValue = arr[i].value
            arr[i].value = 0
            arr[i].addValue = tempValue
        end
    end
    for i = 1, len do
        if self.ObjList[i] == nil then
            local label = UICreate.createLabel(self.content, "", 30, 118, 227, 30, 24);
            label.overflowMethod = UILabel.Overflow.ResizeFreely;
            label.pivot = UIWidget.Pivot.Left;
            label:setDepth(6);
            label.text = "[3F6180]" .. arr[i].attrName .. "：[-][192e41]" .. arr[i].value
            label:setLocation(155, -80 -(i - 1) * 35, 0);
            local offsetX = 0
            offsetX = label.mainContent.transform.localPosition.x + label.width + 15

            local arrow = UICreate.createUIAtlasImage(self.content, "iconantlas1", "arrow_up", 0, 0, 0, 0);
            arrow:setLocation(offsetX + 10, -80 -(i - 1) * 35, 0);
            arrow:setDepth(6)
            arrow:setEnable(true)
            local offsetX2 = 0
            offsetX2 = arrow.mainContent.transform.localPosition.x + 15
            local label2 = UICreate.createLabel(self.content, "", -80, -195, 66, 24, 24);
            label2.pivot = UIWidget.Pivot.Left;
            label2.overflowMethod = UILabel.Overflow.ShrinkContent;
            label2:setDepth(5);
            label2.text = "[13a100]" .. arr[i].addValue
            label2:setLocation(offsetX2, -80 -(i - 1) * 35, 0);

            local list = { }
            list.label = label
            list.arrow = arrow
            list.label2 = label2
            self.ObjList:add(list)
        else
            self.ObjList[i].label.text = "[3F6180]" .. arr[i].attrName .. "：[-][192e41]" .. arr[i].value
            local offsetX = 0
            offsetX = self.ObjList[i].label.mainContent.transform.localPosition.x + self.ObjList[i].label.width + 15
            self.ObjList[i].arrow:setEnable(true)
            self.ObjList[i].arrow:setLocation(offsetX + 10, -80 -(i - 1) * 35, 0);
            local offsetX2 = 0
            offsetX2 = self.ObjList[i].arrow.mainContent.transform.localPosition.x + 15
            self.ObjList[i].label2.text = "[13a100]" .. arr[i].addValue
            self.ObjList[i].label2:setLocation(offsetX2, -80 -(i - 1) * 35, 0);
        end
    end

    local objLen = self.ObjList:getSize();
    if self.state == true then
        self.fuhunBtn:setEnable(false)
        self.stateObj.gameObject:SetActive(true)
        for i = 1, objLen do
            self.ObjList[i].arrow:setEnable(false)
            self.ObjList[i].label2.text = ""
        end
    else
        self.fuhunBtn:setEnable(true)
        self.stateObj.gameObject:SetActive(false)
    end
    if objLen > len then
        for i = len + 1, objLen do
            self.ObjList[i].label.text = ""
            self.ObjList[i].arrow:setEnable(false)
            self.ObjList[i].label2.text = ""
        end
    end
end

function Lua_EquipDuanHunPanel.Get:iconPosList()
    if self._iconPos == nil then
        self._iconPos = Array()
        self._iconPos:add( { x = - 447, y = - 220 })
        self._iconPos:add( { x = - 348, y = - 240 })
        self._iconPos:add( { x = - 248, y = - 250 })
        self._iconPos:add( { x = - 148, y = - 240 })
        self._iconPos:add( { x = - 49, y = - 220 })
    end
    return self._iconPos
end

function Lua_EquipDuanHunPanel:dispose()
    if self.effect ~= nil then
        self.effect:dispose()
    end
    self:superCall("dispose");
end