﻿
Lua_EquipKaiGuangPanel = class("Lua_EquipKaiGuangPanel", Lua_DisplayObject);
function Lua_EquipKaiGuangPanel:ctor(p)
    self:superCall("ctor", p, "KaiGuangPanel_skin");
end
function Lua_EquipKaiGuangPanel:buildShowItem()
    self:superCall("buildShowItem");
    self:addLuaEvent("UPDATE_FUHUNPANEL_INFO", self, self.onUpdateInfo)
    self.helpIcon:addClickFuntion(self, self.onHelpClick)
    self.kaiguangBtn:addClickFuntion(self, self.onKaiGuangClick)
    self.left:addClickFuntion(self, self.onLeftClick)
    self.right:addClickFuntion(self, self.onRightClick)
    self.skillIcon:addClickFuntion(self, self.onSkillClick)
    self.suitIcon:addClickFuntion(self, self.onSuitClick)
    self.kaiguangBtn:setEnable(false)
    self.stateObj.gameObject:SetActive(false)

    self.redDot = UICreate.createUIAtlasImage(self.kaiguangBtn.mainContent, "iconantlas4", "redDot", 60, 16, 0, 0)
    self.redDot:setDepth(9);
    self.redDot.clickScale = false;
    self.redDot.name = "redDot"
    self.redDot:setEnable(false);

    self.effect = UICreate.createUIEffect(self.content, nil, nil, 0, 0);
    self.effect:setSacle(1, 1, 1);
    self.effect:SetRenderQueue(self.txt3, 5, 2, false);
    self.effect:setLocation(-250, -45)
    self.effect:setEnable(true)

    self.ItemArr = Array()
    self.IconArr = Array()
    self.ItemList = Array()
    self.ObjList = Array()
    self.ItemArr:add(self.dipan_1)
    self.ItemArr:add(self.dipan_2)
    self.ItemArr:add(self.dipan_3)
    self.ItemArr:add(self.dipan_4)
    self.ItemArr:add(self.dipan_5)
    self.ItemArr:add(self.dipan_6)
    self.ItemArr:add(self.dipan_7)
    self.ItemArr:add(self.dipan_8)
    self.ItemArr:add(self.dipan_9)
    self.ItemArr:add(self.dipan_10)
    self.ItemArr:add(self.dipan_11)
    self.ItemArr:add(self.dipan_12)
    self.selectedPart = 12
    Lua_ProxyManager.getProxy("Lua_FuHunProxy"):sInitMsg()
end 

function Lua_EquipKaiGuangPanel:onSkillClick()
    Lua_WindowUtil.openWin("Lua_FuHunSkillWindow", WinParam.ACTION_OPEN)
end

function Lua_EquipKaiGuangPanel:onSuitClick()
    Lua_WindowUtil.openWin("Lua_FuHunSuitWindow", WinParam.ACTION_OPEN)
end

function Lua_EquipKaiGuangPanel:onCreateItem()
    local index = 0
    for i = 12, 1, -1 do
        index = index + 1
        local equipdata = DataCenter.fuHunData:getFuHunInfoByPart(i)
        if self.IconArr[index] == nil then
            local timg = Lua_ToolImage.new(self.content);
            timg:setDepth(6);
            timg:setLocation(self.ItemArr[index].mainContent.transform.localPosition.x, self.ItemArr[index].mainContent.transform.localPosition.y + 35);
            timg.content.name = i;
            timg:setDefaultIcon("fuhunWindow", equipdata.kaiguang_icon);
            timg:setScale(0.9, 0.9)
            timg:showDefaultIcon(not equipdata.kaiGuangState)
            timg:setDefaultIconGray(not equipdata.kaiGuangState)

            timg:removeFun(false)
            timg.item_bg:addClickFuntion(self, self.onIconClick);
            timg.item_bg.alpha = 0.01

            local label = UICreate.createLabel(timg.mainContent, nil, -36, 25, 71, 22, 22);
            label.overflowMethod = UILabel.Overflow.ResizeFreely;
            label.effectStyle = 3;
            label.effectColorStr = Lua_ColorDefine.transColor("192e41");
            label.pivot = UIWidget.Pivot.Left;
            label:setDepth(9);
            label.text = equipdata.open_light_level

            local effect = UICreate.createUIEffect(timg.mainContent, "/effects/scsEffects/" .. equipdata.kaiguang_small_effect, equipdata.kaiguang_small_effect, 0, 0);
            effect:setSacle(1, 1, 1);
            effect:SetRenderQueue(self.txt3, 5, 2);
            effect:setEnable(equipdata.kaiGuangState)

            local redDot = UICreate.createUIAtlasImage(timg.mainContent, "iconantlas4", "redDot", 28, 28, 0, 0)
            redDot:setDepth(9);
            redDot.clickScale = false;
            redDot.name = "redDot"
            redDot:setEnable(equipdata.kaiGuangRedDot);

            local list = { }
            list.item = timg
            list.redDot = redDot
            list.label = label
            list.index = index
            list.effect = effect
            list.part = i
            self.IconArr:add(list)
        else
            self.IconArr[index].label.text = DataCenter.fuHunData:getFuHunInfoByPart(self.IconArr[index].part).open_light_level
            self.IconArr[index].redDot:setEnable(DataCenter.fuHunData:getFuHunInfoByPart(self.IconArr[index].part).kaiGuangRedDot);
            self.IconArr[index].effect:setEnable(DataCenter.fuHunData:getFuHunInfoByPart(self.IconArr[index].part).kaiGuangState)
            self.IconArr[index].item:showDefaultIcon(not DataCenter.fuHunData:getFuHunInfoByPart(self.IconArr[index].part).kaiGuangState)
            self.IconArr[index].item:setDefaultIconGray(not DataCenter.fuHunData:getFuHunInfoByPart(self.IconArr[index].part).kaiGuangState)

        end
    end
end
function Lua_EquipKaiGuangPanel:onHelpClick()
    Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(141314));
end

function Lua_EquipKaiGuangPanel:onKaiGuangClick()
    if self.equipData == nil then
        return
    end
    Lua_ProxyManager.getProxy("Lua_FuHunProxy"):sKaiGuangMsg(self.selectedPart)
end
function Lua_EquipKaiGuangPanel:onLeftClick()
    if self.equipData == nil then
        return
    end
    self.selectedPart = self.selectedPart + 1
    if self.selectedPart > 12 then
        self.selectedPart = 1
    end
    self:onIconClick(self.selectedPart)
end

function Lua_EquipKaiGuangPanel:onRightClick()
    if self.equipData == nil then
        return
    end
    self.selectedPart = self.selectedPart - 1
    if self.selectedPart < 1 then
        self.selectedPart = 12
    end
    self:onIconClick(self.selectedPart)
end

function Lua_EquipKaiGuangPanel:onUpdateInfo()
    self:onCreateItem()
    self:onIconClick(self.selectedPart)
end

function Lua_EquipKaiGuangPanel:findGoIndex(index)
    local len = self.IconArr:getSize()
    for i = 1, len do
        if index == self.IconArr[i].part then
            return self.IconArr[i]
        end
    end
    return nil;
end
function Lua_EquipKaiGuangPanel:onIconClick(go)
    local offset = 0
    local index
    if type(go) ~= "number" then
        index = tonumber(go.transform.parent.name)
    else
        index = go
    end
    self.data = self:findGoIndex(index)
    index = self.data.index
    self.selectedPart = self.data.part
    self.equipData = DataCenter.fuHunData:getFuHunInfoByPart(self.selectedPart)
    self.txt3.text = self.equipData.name
    self.effect:setUrl("/effects/scsEffects/" .. self.equipData.kaiguang_big_effect, self.equipData.kaiguang_big_effect)
    self:onUpdataInfoByPart()
    self.direct = 1
    if index - 7 > 0 then
        offset = 12 - index + 1
        self.direct = 0
    else
        offset = index - 1
    end
    self.offset = offset
    Lua_CommonUtil.addTimer("onPlayAnim", 0.01, self, self.onPlayAnim);
end

function Lua_EquipKaiGuangPanel:onPlayAnim(param)
    self.offset = self.offset - 1
    if self.offset >= 0 then
        local len = self.IconArr:getSize()
        for i = 1, len do
            if self.direct == 0 then
                self.IconArr[i].index =(self.IconArr[i].index + 1) % 12
            else
                self.IconArr[i].index =(self.IconArr[i].index - 1) % 12
            end
            if self.IconArr[i].index == 0 then
                self.IconArr[i].index = 12
            end
            local posX = self.ItemArr[self.IconArr[i].index].mainContent.transform.localPosition.x;
            local posY = self.ItemArr[self.IconArr[i].index].mainContent.transform.localPosition.y + 45;
            TweenUtil.getInstance():addTween(self.IconArr[i].item.content, 0.1, 0, Vector3(posX, posY, 0), nil, Vector3(0.9, 0.9, 0.9));
        end
    else
        Lua_CommonUtil.removeTimer(self.onPlayAnim)
    end
end


function Lua_EquipKaiGuangPanel:onUpdataInfoByPart()
    self:showCostItem()
    self:showAttrInfo()
end 

function Lua_EquipKaiGuangPanel:showCostItem()
    local configData = DataCenter.fuHunData.equipKaiGuangConfig[self.selectedPart * 10000 + self.equipData.open_light_level + 1]
    local costItemList
    self.maxState = false
    local len = 0
    if configData == nil then
        self.maxState = true
    else
        costItemList = configData["cost"]
        len = #costItemList
    end
    if self.maxState == false then
        self.kaiguangBtn:setEnable(true)
        self.stateObj.gameObject:SetActive(false)
    else
        self.kaiguangBtn:setEnable(false)
        self.stateObj.gameObject:SetActive(true)
    end
    self.redDot:setEnable(self.equipData.kaiGuangRedDot)
    self.costItemId = 0
    local startX = 324
    local objLen = self.ItemList:getSize();
    for i = 1, objLen do
        self.ItemList[i]:dispose()
    end
    self.ItemList:clear()
    for i = 1, len do
        local item = Lua_ToolImage.new(self.content);
        item:setDepth(7);
        item:setLocation(startX +(i - 1) * 90, -150, 0);
        item.data = Lua_ToolVo.new(costItemList[i][1])
        item.content.name = i
        local hadCount = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(costItemList[i][1]);
        item:showNumLimit(hadCount, costItemList[i][2], 2)
        if hadCount < costItemList[i][2] then
            self.costItemId = costItemList[i][1]
        end
        self.ItemList:add(item)
    end
end

function Lua_EquipKaiGuangPanel:getAttrArr()
    local arr = Array()
    local curKey = self.selectedPart * 10000 + self.equipData.open_light_level
    local nextKey = self.selectedPart * 10000 + self.equipData.open_light_level + 1
    local cur_configData = DataCenter.fuHunData.equipKaiGuangConfig[curKey]
    local next_configData = DataCenter.fuHunData.equipKaiGuangConfig[nextKey]
    for k, v in ipairs(Lua_ThingDefine.params) do
        local list = { }
        list.value = 0
        list.addValue = 0
        list.rank = Lua_ThingDefine.getParaRankByParams(v)
        list.attrName = Lua_ThingDefine.getParamName(v)
        list.isPercent = Lua_ThingDefine.isPercentParam(v)
        if cur_configData ~= nil then
            if cur_configData[v] ~= nil then
                list.value = cur_configData[v]
                if next_configData ~= nil then
                    if next_configData[v] ~= nil then
                        list.addValue = next_configData[v] - cur_configData[v]
                        if list.isPercent == true then
                            list.value = list.value .. "%"
                            list.addValue = list.addValue .. "%"
                        end
                        arr:add(list)
                    end
                else
                    list.addValue = ""
                    self.state = true
                    if list.isPercent == true then
                        list.value = list.value .. "%"
                    end
                    arr:add(list)
                end
            end
        else
            if next_configData[v] ~= nil then
                list.addValue = next_configData[v]
                if list.isPercent == true then
                    list.value = list.value .. "%"
                    list.addValue = list.addValue .. "%"
                end
                arr:add(list)
            end
        end
    end
    arr:sort("rank", false)
    return arr
end

function Lua_EquipKaiGuangPanel:showAttrInfo()
    self.state = false
    local arr = self:getAttrArr()
    for i = 1, len do
        if self.ObjList[i] == nil then
            local label = UICreate.createLabel(self.content, "", 30, 118, 227, 30, 24);
            label.overflowMethod = UILabel.Overflow.ResizeFreely;
            label.pivot = UIWidget.Pivot.Left;
            label:setDepth(6);
            label.text = "[3F6180]" .. arr[i].attrName .. "：[-][192e41]" .. arr[i].value
            label:setLocation(155, 150 -(i - 1) * 35, 0);
            local offsetX = 0
            offsetX = label.mainContent.transform.localPosition.x + label.width + 15

            local arrow = UICreate.createUIAtlasImage(self.content, "iconantlas1", "arrow_up", 0, 0, 0, 0);
            arrow:setLocation(offsetX + 10, 150 -(i - 1) * 35, 0);
            arrow:setDepth(6)
            arrow:setEnable(true)
            local offsetX2 = 0
            offsetX2 = arrow.mainContent.transform.localPosition.x + 15
            local label2 = UICreate.createLabel(self.content, "", -80, -195, 66, 24, 24);
            label2.pivot = UIWidget.Pivot.Left;
            label2.overflowMethod = UILabel.Overflow.ShrinkContent;
            label2:setDepth(5);
            label2.text = "[13a100]" .. arr[i].addValue
            label2:setLocation(offsetX2, 150 -(i - 1) * 35, 0);

            local list = { }
            list.label = label
            list.arrow = arrow
            list.label2 = label2
            self.ObjList:add(list)
        else
            self.ObjList[i].label.text = "[3F6180]" .. arr[i].attrName .. "：[-][192e41]" .. arr[i].value
            local offsetX = 0
            offsetX = self.ObjList[i].label.mainContent.transform.localPosition.x + self.ObjList[i].label.width + 15
            self.ObjList[i].arrow:setEnable(true)
            self.ObjList[i].arrow:setLocation(offsetX + 10, 150 -(i - 1) * 35, 0);
            local offsetX2 = 0
            offsetX2 = self.ObjList[i].arrow.mainContent.transform.localPosition.x + 15
            self.ObjList[i].label2.text = "[13a100]" .. arr[i].addValue
            self.ObjList[i].label2:setLocation(offsetX2, 150 -(i - 1) * 35, 0);
        end
    end

    local objLen = self.ObjList:getSize();
    if self.state == true then
        for i = 1, objLen do
            self.ObjList[i].arrow:setEnable(false)
            self.ObjList[i].label2.text = ""
        end
    end
    if objLen > len then
        for i = len + 1, objLen do
            self.ObjList[i].label.text = ""
            self.ObjList[i].arrow:setEnable(false)
            self.ObjList[i].label2.text = ""
        end
    end
end 

function Lua_EquipKaiGuangPanel:dispose()
    self:superCall("dispose");
end