checkRequire("Lua_EquipDuanHunPanel")
checkRequire("Lua_EquipKaiGuangPanel")

Lua_FuHunPanel = class("Lua_FuHunPanel", Lua_DisplayObject);
function Lua_FuHunPanel:ctor(p)
    self:superCall("ctor", p);
end
function Lua_FuHunPanel:buildShowItem()
    self:superCall("buildShowItem");
    self.initIndex = 1
    self.isFirstClick = true

    self.btnNames = Array();
    self.btnNames:add( { name = LanUtil.getValue(141301), panel = Lua_EquipDuanHunPanel, eventIds = { 10816, 10817 }, openId = 10204 });
    self.btnNames:add( { name = LanUtil.getValue(141302), panel = Lua_EquipKaiGuangPanel, eventIds = { 10818 }, openId = 10204 });

    self.forgingList = Lua_ButtonList.new(self.content, self.btnNames, 148, self, self.onButtonListClick,
    	"tab1_souchong_normal", "tab1_souchong_select", Vector4(0, 0, 125, 50), Vector4(0, 0, 134, 59),
    	Lua_ColorDefine.transColor("394463"), Lua_ColorDefine.transColor("742c00"), Vector4(24, 26, 120, 30), 2);
    self.forgingList:setLocation(-540, 251, 0);
    self.forgingList:setDepth(5);
    self.forgingList:setRedDotPos(55, 15)
    local len = self.btnNames:getSize()


    local initIndex = 1
    local winData = DataCenter.packData.PackWindowData
    if winData ~= nil and type(winData) == "number" then
        initIndex = winData
    elseif winData ~= nil and winData.nameIndex ~= nil then
        for i = 1, len do
            if self.btnNames[i].name == LanUtil.getValue(winData.nameIndex) then
                initIndex = i
                break
            end
        end
    end
    self.forgingList:setSelected(initIndex, true);
    for i = 1, len do
        local isShowIcon = true
        if self.btnNames[i].openId == nil or DataCenter.funcOpenData:isOpened(self.btnNames[i].openId) == true then
            self.forgingList:setBtnGray(false, i, isShowIcon);
        else
            local cfg = getConfig( { "func_open", self.btnNames[i].openId });
            if cfg ~= nil and cfg.advance_function ~= nil then
                isShowIcon = cfg.advance_function == 1
            end
            self.forgingList:setBtnGray(true, i, isShowIcon);
        end
    end
end

function Lua_FuHunPanel:onButtonListClick(val)
    if self.initIndex == val and self.isFirstClick == false then
        return
    end
    if self.btnNames[val].openId ~= nil and DataCenter.funcOpenData:isOpened(self.btnNames[val].openId) == false then
        local cfg = getConfig( { "func_open", self.btnNames[val].openId });
        if cfg ~= nil and cfg.advance_message ~= nil then
            OperateAlert.show(cfg.advance_message);
        end
        return
    end

    if self.isFirstClick == true then
        self.isFirstClick = false
    end
    self.initIndex = val
    if self.panel ~= nil then
        self.panel:dispose()
        self.panel = nil
    end
    if self.btnNames[self.initIndex].panel == nil then
        return
    end
    self.panel = self.btnNames[self.initIndex].panel.new(self.content)
end

function Lua_FuHunPanel:dispose()
    if self.forgingList ~= nil then
        self.forgingList:dispose()
        self.forgingList = nil
    end
    DataCenter.packData.PackWindowData = nil
    self:superCall("dispose");
end
