Lua_FuHunSkillWindow = class("Lua_FuHunSkillWindow", Lua_Window);
function Lua_FuHunSkillWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_FuHunSkillWindow";
	self.skinName = "FuHunSkillPanel_skin";
	self.blackAlpha = 1 / 255;
	self.showClose = false;
	self.isClickClose = true;
end

function Lua_FuHunSkillWindow:buildShowItem()
	self:superCall("buildShowItem");

	local lvl = DataCenter.fuHunData.suit_skill_level;
	local num = DataCenter.fuHunData.suit_skill_count;
	local count = DataCenter.fuHunData.equipSuitConfig.skill_max_count;
	self.titleNameLab.text = LanUtil.formateStr(LanUtil.getValue(141318), tostring(lvl), tostring(num), tostring(count));

	local maxLvl = #DataCenter.fuHunData.equipSuitConfig.suit_up_condition[2];
	self.IsMax = lvl >= maxLvl;
	
	local arr = self:getShowPartArr();
	if lvl >= maxLvl then
		self.winBg:SetDimensions(382, 365);
		self.reMarkObj:SetActive(true);
		self.nextObj:SetActive(false);
		self.tipsObj:SetActive(false);

		self.tipsTxt.text = "";
		self.remarkTxt.text = LanUtil.getValue(141320);
		self.remark:setAltas("common_atlas_2", "ui_common_tishi2");
	else
		local curLvl = self:getCurLevel(arr);
		local needLvl = DataCenter.fuHunData.equipSuitConfig.suit_up_condition[2][lvl + 1];
		self.tipsTxt.text = LanUtil.formateStr(LanUtil.getValue(141317), tostring(curLvl), tostring(needLvl));
		
		if num ~= count then
			self.winBg:SetDimensions(382, 365);
			self.reMarkObj:SetActive(true);
			self.nextObj:SetActive(false);
			self.tipsObj:SetActive(false);

			self.remarkTxt.text = LanUtil.getValue(141319);
			self.remark:setAltas("common_atlas_2", "ui_common_tishi");
		else
			self.winBg:SetDimensions(382, 440);
			self.reMarkObj:SetActive(false);
			self.nextObj:SetActive(true);
			self.tipsObj:SetActive(true);
		end
	end
	self:onShowPartInfo(arr);
	self:onShowAttrInfo(lvl);
end

function Lua_FuHunSkillWindow:getShowPartArr()
    local arr = Array();
    for i = 1, 12 do
        local data = DataCenter.fuHunData:getFuHunInfoByPart(i);
        if data ~= nil and data.SkillOrSuit == 2 then
            arr:add(data);
        end
    end
    return arr;
end

function Lua_FuHunSkillWindow:getCurLevel(value)
	local lvl = 0;
	for i = 1, value:getSize() do
		lvl = lvl + value[i].open_light_level;
	end
	return lvl;
end

function Lua_FuHunSkillWindow:onShowPartInfo(value)
	local label;
	local indexX = 0;
	local indexY = 0;
	for i = 1, value:getSize() do
		label = UICreate.createLabel(self.content, "", 0, 0, 70, 22, 22);
		label.name = value[i].part;
		label.overflowMethod = UILabel.Overflow.ResizeFreely;
		label.pivot = UIWidget.Pivot.Right;
		label.text = value[i].partName;
		label:setDepth(3);
		label:setLocation(-160 + indexX * 80, 150 - indexY * 30);

		indexX = indexX + 1;
		if i == 4 then
			indexY = indexY + 1;
			indexX = 0;
		end
	end
end

function Lua_FuHunSkillWindow:onShowAttrInfo(value)
	local skillId = DataCenter.fuHunData.equipSuitConfig.skill_id;
	local skillData = getConfig({"player_skill", skillId});
	local colorStr = value ~= 0 and "[b1caf4]" or "[adadad]";
	local colorStr2 = "[adadad]";
	local str = skillData.reMark;
	local data = skillData.reMark_data;
	if self.IsMax == false then
		if value == 0 then
			self.curDesLab.text = colorStr..LanUtil.formateStr(str, tostring(data[1][1]), tostring(data[1][2]));
		else
			self.curDesLab.text = colorStr..LanUtil.formateStr(str, tostring(data[value][1]), tostring(data[value][2]));
		end
		self.nextDesLab.text = colorStr2..LanUtil.formateStr(str, tostring(data[value + 1][1]), tostring(data[value + 1][2]));
	else
		self.curDesLab.text = LanUtil.formateStr(str, tostring(data[value][1]), tostring(data[value][2]));
		self.nextDesLab.text = "";
	end
end

function Lua_FuHunSkillWindow:dispose()
	self:superCall("dispose");
end