Lua_FuHunSuitWindow = class("Lua_FuHunSuitWindow", Lua_Window);
function Lua_FuHunSuitWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_FuHunSuitWindow";
	self.skinName = "FuHunSuitPanel_skin";
	self.blackAlpha = 1 / 255;
	self.showClose = false;
	self.isClickClose = true;
end

function Lua_FuHunSuitWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.zhuangbei_AttrList = {
		{ "defence", "blood", "reduce_defence_multi" },
		{ "defence", "blood", "blood_multi" },
		{ "defence", "blood", "attack_multi", "defence_multi" }
	}

	self.ObjList = Array();

	local lvl = DataCenter.fuHunData.suit_prop_level;
	local num = DataCenter.fuHunData.suit_prop_count;
	local count = DataCenter.fuHunData.equipSuitConfig.suit_max_count;
	self.titleNameLab.text = LanUtil.formateStr(LanUtil.getValue(141315), tostring(lvl), tostring(num), tostring(count));

	local maxLvl = #DataCenter.fuHunData.equipSuitConfig.suit_up_condition[1];
	self.IsMax = lvl >= maxLvl;

	local arr = self:getShowPartArr();
	if lvl >= maxLvl then
		self.tipsTxt.text = "";

		self.nextLab:setEnable(false);
		self.tipsObj:SetActive(false);
		self.reMarkObj:SetActive(true);
	else
		local curLvl = self:getCurLevel(arr);
		local needLvl = DataCenter.fuHunData.equipSuitConfig.suit_up_condition[1][lvl + 1];
		self.tipsTxt.text = LanUtil.formateStr(LanUtil.getValue(141317), tostring(curLvl), tostring(needLvl));

		self.nextLab:setEnable(num == count);
		self.tipsObj:SetActive(num == count);
		self.reMarkObj:SetActive(false);
	end
	self:onShowPartInfo(arr);
	self:onShowAttrTxt(num, count);
end

function Lua_FuHunSuitWindow:getShowPartArr()
	local arr = Array();
	for i = 1, 12 do
		local data = DataCenter.fuHunData:getFuHunInfoByPart(i);
		if data ~= nil and data.SkillOrSuit == 1 then
			arr:add(data);
		end
	end
	return arr;
end

function Lua_FuHunSuitWindow:getCurLevel(value)
	local lvl = 0;
	local arr = value;
	local len = arr:getSize();
	for i = 1, len do
		lvl = lvl + arr[i].open_light_level;
	end
	return lvl;
end

function Lua_FuHunSuitWindow:onShowPartInfo(value)
	local arr = value;
	local len = arr:getSize();
	local indexX = 0;
	local indexY = 0;
	for i = 1, len do
		local label = UICreate.createLabel(self.content, nil, -36, 25, 71, 22, 22);
		label.name = arr[i].part;
		label.overflowMethod = UILabel.Overflow.ResizeFreely;
		label.pivot = UIWidget.Pivot.Center;
		label:setDepth(3);
		label.text = arr[i].partName;
		label:setLocation(-120 + indexX * 80, 150 - indexY * 35);
		indexX = indexX + 1;
		if i == 4 then
			indexY = indexY + 1;
			indexX = 0;
		end
	end
end

function Lua_FuHunSuitWindow:onGetAttrStrInfo()
	local strArr = Array();
	local configData = DataCenter.fuHunData.equipSuitConfig.attr;
	local attrList = self.zhuangbei_AttrList;
	local value = 0;
	local lvl = DataCenter.fuHunData.suit_prop_level;
	local suitCount = DataCenter.fuHunData.suit_prop_count;
	for i = 1, 3 do
		local listData = attrList[i];
		local listDataLen = #listData;
		local str = "";
		local nextStr = "";
		local count = i * 2;
		if i == 3 then
			count = count + 2;
		end

		local colorStr = "[adadad]";
		local colorStr2 = " [adadad]+";
		if suitCount >= count then
			colorStr = "[b1caf4]";
			colorStr2 = " [eff4fd]+";
		end

		for c = 1, listDataLen do
			local attrName = colorStr .. Lua_ThingDefine.getParamName(listData[c]) .. "[-]";
			local isPercnet = Lua_ThingDefine.isPercentParam(listData[c]);
			-- 精炼对应的值
			local attrValue;
			if lvl ~= 0 then
				attrValue = colorStr2 .. configData[i][listData[c]][lvl];
			else
				attrValue = colorStr2 .. configData[i][listData[c]][1];
			end

			local nextValue;
			if self.IsMax == false then
				nextValue = "[00E125]+" .. configData[i][listData[c]][lvl + 1];
			else
				nextValue = "";
			end

			local percentStr = isPercnet == true and "%" or "";
			local fenhang = c == listDataLen and "" or "\n";
			attrValue = attrValue .. percentStr;
			nextValue = nextValue .. percentStr;
			str = str .. attrName .. attrValue .. fenhang;
			nextStr = nextStr .. nextValue .. fenhang;
			if self.IsMax == true then
				nextStr = "";
			end
		end
		strArr:add({str = str, nextStr = nextStr});
	end
	return strArr;
end

function Lua_FuHunSuitWindow:onShowAttrTxt(num, maxCount)
	local strArr = self:onGetAttrStrInfo();
	local len = strArr:getSize();
	local suitCount = DataCenter.fuHunData.suit_prop_count;
	self.dh = 45;
	for i = 1, len do
		local count = i * 2;
		if i == len then
			count = count + 2;
		end

		local colorStr = "[adadad]";
		if suitCount >= count then
			colorStr = "[b1caf4]";
		end

		if self.ObjList[i] == nil then
			local countlabel = UICreate.createLabel(self.content, "", -120, 53, 227, 30, 22);
			countlabel.overflowMethod = UILabel.Overflow.ResizeFreely;
			countlabel.pivot = UIWidget.Pivot.TopLeft;
			countlabel.text = colorStr .. LanUtil.formateStr(LanUtil.getValue(141316), tostring(count));
			countlabel:setDepth(6);
			countlabel:setLocation(-160, self.dh, 0);

			local deslabel = UICreate.createLabel(self.content, "", 0, 0, 227, 30, 24);
			deslabel.overflowMethod = UILabel.Overflow.ResizeFreely;
			deslabel.pivot = UIWidget.Pivot.TopLeft;
			deslabel.text = strArr[i].str;
			deslabel:setDepth(6);
			deslabel:setLocation(-100, self.dh, 0);

			local nextlabel = UICreate.createLabel(self.content, "", 0, 0, 227, 30, 24);
			nextlabel.overflowMethod = UILabel.Overflow.ResizeFreely;
			nextlabel.pivot = UIWidget.Pivot.TopLeft;
			nextlabel.text = num == maxCount and strArr[i].nextStr or "";
			nextlabel:setDepth(6);
			nextlabel:setLocation(100, self.dh, 0);

			self.ObjList:add({countlabel = countlabel, deslabel = deslabel, nextlabel = nextlabel});
			self.dh = self.dh - deslabel.height - 20;
		else
			self.ObjList[i].countlabel.text = colorStr .. LanUtil.formateStr(LanUtil.getValue(141316), tostring(count));
			self.ObjList[i].deslabel.text = strArr[i].str;
			self.ObjList[i].nextlabel.text = strArr[i].nextStr;
			if num == maxCount then
				self.ObjList[i].nextlabel.text = strArr[i].nextStr;
			else
				self.ObjList[i].nextlabel.text = "";
			end
		end
	end

	local objLen = self.ObjList:getSize();
	if objLen > len then
		for i = len + 1, objLen do
			self.ObjList[i].countlabel:dispose();
			self.ObjList[i].deslabel:dispose();
			self.ObjList[i].nextlabel:dispose();
		end
	end
end

function Lua_FuHunSuitWindow:dispose()
	self:superCall("dispose");
end