Lua_BatchSaleItems = class("Lua_BatchSaleItems", Lua_DragContainerItem);
function Lua_BatchSaleItems:ctor(p)
	self:superCall("ctor", p);
end
function Lua_BatchSaleItems:buildShowItem()
	self:superCall("buildShowItem");
	self.cells = Array();
	local cellSize = 30;
	local perWidth = 90;
	local perHeight = 90;
	for i=1,cellSize do
		local c = Lua_ToolImage.new(self.content);

		local px = (i - 1) % 6;
		local py = math.ceil(i / 6);
		c.defaultRoundEffect = true;
		c:setLocation(- 1 * perWidth * 6 / 2 + px * perWidth + perWidth / 2, perHeight / 2 + perHeight * 4 / 2  - perHeight * py, 0);
		c:setDepth(13);
		c:setCanClick(false);
		self.cells:add(c);
	end
end
function Lua_BatchSaleItems:checkOutBound(showRect)
	local len = self.cells:getSize();
	for i=1,len do
		if self.cells[i].data ~= nil then
			local rect = Lua_Rectangle.new(self.x + self.cells[i].x - 40, self.y + self.cells[i].y - 40, 80,80);
			if showRect:containeRect(rect) == true then
				self.cells[i]:showRoundEffectView(true);
			else
				self.cells[i]:showRoundEffectView(false);
			end
		end
	end
end
function Lua_BatchSaleItems:updateItems(arr)
	local len = self.cells:getSize();
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	for i=1,len do
		if arr[i] ~= nil then
			local tvo = arr[i].data;
			self.cells[i].data = tvo;
			self.cells[i]:showNum(arr[i].num);
			self.cells[i]:showCloseSp(true, true, "REMOVE_SALE_ITEM");
		else
			self.cells[i].data = nil;
			self.cells[i]:showCloseSp(false);
		end
	end
end
function Lua_BatchSaleItems:getHeight()
	return 450;
end