checkRequire("Lua_BatchSaleItems");
Lua_BatchSalePanel = class("Lua_BatchSalePanel", Lua_DisplayObject);
function Lua_BatchSalePanel:ctor(p)
	self:superCall("ctor", p, "BatchSalePanel_skin");
end
function Lua_BatchSalePanel:buildShowItem()
	self:superCall("buildShowItem");

	self.barPanel = self.content:AddComponent(typeof(UIPanel));  
    self.barPanel.cullWhileDragging = false;
    self.barPanel.softBorderPadding = false;

	self.bg.clickScale = false;
	self.bg:addClickFuntion(self, self.onBgClick);

	self.dragContainer = Lua_DragContainer.new(self.content,1, Vector4(0, 0, 548, 360));
	self.itemsObj = Lua_BatchSaleItems.new(self.dragContainer.content);
	self.dragContainer:addSubContainer(self.itemsObj, true);
	self.dragContainer:setLocation(-305, 70, 0);

	self.moneyIcon:setAltas(Lua_MoneyData.getMoneyIconAtlas(Lua_MoneyData.COPPER), Lua_MoneyData.getIconSpByMoneyType(Lua_MoneyData.COPPER));
	self.moneyTxt.text = "0";
	self.guolvTxt.text = LanUtil.getValue(20);

	self.guolvBg:addClickFuntion(self, self.onGuolvClick);
	self.numBg1:addClickFuntion(self, self.onGuolvClick);

	self.saleBtn:addClickFuntion(self, self.onSaleClick);

	self:addLuaEvent("UPDATE_SALE_ITEM", self, self.onUpdateSaleItem);
	self:addLuaEvent("REMOVE_SALE_ITEM", self, self.onRemoveSaleItem);
	self:addLuaEvent("PACK_ZHENGLI", self, self.onPackZhengliClick);
	self:onUpdateSaleItem(nil);

	WindowMananger.getInstance():resetChildParent(self.content.transform);
end
function Lua_BatchSalePanel:onGuolvClick(go)
	local dragData = {};
	dragData.datas = Array();
	dragData.datas:add(LanUtil.formateStr(LanUtil.getValue(110899), LanUtil.getValue(110809)));
	dragData.datas:add(LanUtil.formateStr(LanUtil.getValue(110899), LanUtil.getValue(110810)));
	dragData.datas:add(LanUtil.formateStr(LanUtil.getValue(110899), LanUtil.getValue(110811)));
	dragData.datas:add(LanUtil.formateStr(LanUtil.getValue(110899), LanUtil.getValue(20)));
	dragData.fontSize = 22;
	dragData.offsetX = -416;
	dragData.offsetY = -22;
	dragData.callBackOwner = self;
	dragData.callBack = self.onDragDownCallBack;
	dragData.selected = self.guolvType;
	Lua_WindowUtil.openWin("Lua_DragDownWindow", nil, dragData);
end
function Lua_BatchSalePanel:onDragDownCallBack(val)
	self:setGuolvType(val);
end
function Lua_BatchSalePanel:onBgClick(go)
end
function Lua_BatchSalePanel:onUpdateSaleItem(val)
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	local saleDic = bagData.saleDic;
	local arr = Array();
	local saleNum = 0;
	for k,v in pairs(saleDic) do
		local index = tonumber(k);
		local itemData = bagData:getItemByIndex(index);
		arr:add({data=itemData,num=v});
		saleNum = saleNum + itemData.sysPrice * v;
	end
	self.itemsObj:updateItems(arr);
	self.moneyTxt.text = tostring(saleNum);
end
function Lua_BatchSalePanel:onRemoveSaleItem(o)
	if o == nil then
		return;
	end
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	bagData.saleDic[o.index] = nil;
	Lua_MsgUtil.callFunc("UPDATE_SALE_ITEM");
end
function Lua_BatchSalePanel:setEnable(val)
	self:superCall("setEnable", val);
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	bagData:clearSaleList();
	local arr = Array();
	self.itemsObj:updateItems(arr);
	if val == true then
		self:setGuolvType(3);
	end
end
function Lua_BatchSalePanel:setGuolvType(val)
	self.guolvType = val;
	self.saleColor = -1;
	if val == 1 then
		self.guolvTxt.text = LanUtil.formateStr(LanUtil.getValue(110899), LanUtil.getValue(110809));
		saleColor = 4;
	elseif val == 2 then
		self.guolvTxt.text = LanUtil.formateStr(LanUtil.getValue(110899),LanUtil.getValue(110810));
		saleColor = 3;
	elseif val == 3 then
		self.guolvTxt.text = LanUtil.formateStr(LanUtil.getValue(110899),LanUtil.getValue(110811));
		saleColor = 2;
	elseif val == 4 then
		self.guolvTxt.text = LanUtil.formateStr(LanUtil.getValue(110899),LanUtil.getValue(20));
		saleColor = -1;
	end

	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	local saleDic = bagData.saleDic;
	local arr = Array();
	local saleNum = 0;
	for k,v in pairs(saleDic) do
		local index = tonumber(k);
		local itemData = bagData:getItemByIndex(index);
		if itemData.type == 1 then
			arr:add(index);
		end
	end
	local len = arr:getSize();
	for i=1,len do
		saleDic[arr[i]] = nil;
	end
	local salNum = 0;
	for k,v in pairs(saleDic) do
		salNum = salNum + 1;
	end
	local equList = bagData:getItemsBySubType({Lua_PackTypeDefine.EQUIP});
	len = equList:getSize();
	for i=1,len do
		local itemData = equList[i];
		if itemData.color <= saleColor 
			and salNum < 30
			and itemData.rare == false then
			salNum = salNum + 1;
			saleDic[itemData.index] = itemData.count;
		end
	end
	Lua_MsgUtil.callFunc("UPDATE_SALE_ITEM");
end
function Lua_BatchSalePanel:onSaleClick(go)
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	local saleDic = bagData.saleDic;
	local arr = Array();
	local hasRare = false;
	for k,v in pairs(saleDic) do
		local index = tonumber(k);
		local itemData = bagData:getItemByIndex(index);
		if itemData.rare == true then
			hasRare = true;
			break;
		end
	end
	self:doSale();
end
function Lua_BatchSalePanel:doSale(obj)
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	local saleDic = bagData.saleDic;
	local arr = Array();
	for k,v in pairs(saleDic) do
		local index = tonumber(k);
		local itemData = bagData:getItemByIndex(index);
		arr:add({index=itemData.index, count=v});
	end
	if arr:getSize() <= 0 then
		OperateAlert.show(LanUtil.getValue(110836));
		return;
	end
	local cmd = ProtoPublic_pb.Proto11400134();
	for i=1,arr:getSize() do
		local good = ProtoPublic_pb.ProtoItemSellInfo();
		good.pack_index = arr[i].index;
		good.sell_number = arr[i].count;
		cmd.goods_list:addToList(good);
	end
	sendMsg(11400134, cmd);
	bagData.saleDic = {};
	Lua_MsgUtil.callFunc("UPDATE_SALE_ITEM");
end
function Lua_BatchSalePanel:onPackZhengliClick(o)
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	bagData.saleDic = {};
	Lua_MsgUtil.callFunc("UPDATE_SALE_ITEM");
end