Lua_CombineEightPanel = class("Lua_CombineEightPanel", Lua_DisplayObject);
function Lua_CombineEightPanel:ctor(p)
	self:superCall("ctor", p, "CombineEightPanel_skin");
	self.addRateItems = {0,0,0,0};--{123123}
end
function Lua_CombineEightPanel:buildShowItem()
	self:superCall("buildShowItem");
	self.oneBtn:addClickFuntion(self, self.onOneClick);
	self.combineBtn:addClickFuntion(self, self.onCombineClick);
	self.addSp1:addClickFuntion(self, self.onAddClick1);
	self.addSp2:addClickFuntion(self, self.onAddClick2);
	self.addSp3:addClickFuntion(self, self.onAddClick3);
	self.addSp4:addClickFuntion(self, self.onAddClick4);

	self:addLuaEvent("RATE_ITEM_SELECTED", self, self.onRateItemSelected);
	self:addLuaEvent("REMOVE_RATE_ITEM_1", self, self.onRemoveRateItem1);
	self:addLuaEvent("REMOVE_RATE_ITEM_2", self, self.onRemoveRateItem2);
	self:addLuaEvent("REMOVE_RATE_ITEM_3", self, self.onRemoveRateItem3);
	self:addLuaEvent("REMOVE_RATE_ITEM_4", self, self.onRemoveRateItem4);
	--self:addLuaEvent("ITEM_COMBINE_UPDATE", self, self.onItemCombineUpdate);

	local poses = {{-312,159}, {-312,54},{-312,-42}, {-312,-150}};
	self.materlsArr = Array();
	for i,v in ipairs(poses) do
		local tvi = Lua_ToolImage.new(self.content);
		tvi:setLocation(v[1],v[2],0);
		tvi:setDepth(3);
		tvi.isShowBtns = false;
		self.materlsArr:add(tvi);
	end

	local addImagePos = {{82,159}, {82,54}, {82,-42}, {82,-150}};
	self.addsArr = Array();
	for i,v in ipairs(addImagePos) do
		local tvi = Lua_ToolImage.new(self.content);
		tvi:setLocation(v[1],v[2],0);
		tvi:setDepth(3);
		tvi.isShowBtns = false;
		self.addsArr:add(tvi);
	end

	self.mainImage = Lua_ToolImage.new(self.content);
	self.mainImage:setDepth(5);
	self.mainImage:setLocation(-114,8,0);
	self.mainImage.isShowBtns = false;
end
function Lua_CombineEightPanel:onItemCombineUpdate(o)
	if self.data ~= nil then
		self.addRateItems = {0,0,0,0};
		self:setData(self.data);
	end
end
function Lua_CombineEightPanel:setData(val)
	self.data = val;
	local tvo = Lua_ToolVo.createToolVo(val.output);
	tvo.darkColor = true;
	self.mainImage.data = tvo;
	self.itemNameTxt.text = tvo.colorName;
	local useNumDic = {};
	local materials = val.materials;
	for i=1,4 do
		if materials[i] ~= nil then
			self.materlsArr[i].data = materials[i];
			self.materlsArr[i]:showLockSlot(false);
			local bagNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(materials[i].id);
			if useNumDic[materials[i].id] == nil then
				useNumDic[materials[i].id] = 0;
			end
			local useNum = useNumDic[materials[i].id];
			local leftNum = bagNum - useNum;
			if leftNum < 0 then
				leftNum = 0;
			end
			self.materlsArr[i]:showNumLimit(leftNum, materials[i].count, 2);
			useNumDic[materials[i].id] = useNumDic[materials[i].id] + materials[i].count;
		else
			self.materlsArr[i].data = nil;
			self.materlsArr[i]:showLockSlot(true);
		end
	end
	self:updateAddRateItem();
end
function Lua_CombineEightPanel:setEnable(val)
	if val == true then
		self.addRateItems = {0,0,0,0};
		self:updateAddRateItem();
	else
		self.addRateItems = {0,0,0,0};
	end
	self:superCall("setEnable", val);
end
function Lua_CombineEightPanel:onOneClick(go)
	local rate = self.data.rate;
	local putItem = {};
	local rateItem = self.data.rateItem;
	for i=1, 4 do
		local hasItem = false;
		for j=1,rateItem:getSize() do
			local packNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(rateItem[j].itemId);
			local useNum = putItem[rateItem[j].itemId] == nil and 0 or putItem[rateItem[j].itemId];
			if packNum > useNum then
				self.addRateItems[i] = rateItem[j].itemId;
				rate = rate + self.data:getRateItemRate(rateItem[j].itemId);
				hasItem = true;
				if putItem[rateItem[j].itemId] == nil then
					putItem[rateItem[j].itemId] = 1;
				else
					putItem[rateItem[j].itemId] = putItem[rateItem[j].itemId] + 1;
				end
				break;
			end
		end
		if hasItem == false or rate >= 100 then
			break;
		end
	end
	self:updateAddRateItem();
end
function Lua_CombineEightPanel:onCombineClick(go)
	Lua_PackUtil.combineItem(self.data, self.addRateItems);
end
function Lua_CombineEightPanel:onAddClick1(go)
	Lua_WindowUtil.openWin("Lua_ItemMaterailWindow", nil, {index=1, addedItems=self.addRateItems, combineData=self.data});
end
function Lua_CombineEightPanel:onAddClick2(go)
	Lua_WindowUtil.openWin("Lua_ItemMaterailWindow", nil, {index=2, addedItems=self.addRateItems, combineData=self.data});
end
function Lua_CombineEightPanel:onAddClick3(go)
	Lua_WindowUtil.openWin("Lua_ItemMaterailWindow", nil, {index=3, addedItems=self.addRateItems, combineData=self.data});
end
function Lua_CombineEightPanel:onAddClick4(go)
	Lua_WindowUtil.openWin("Lua_ItemMaterailWindow", nil, {index=4, addedItems=self.addRateItems, combineData=self.data});
end
function Lua_CombineEightPanel:onRateItemSelected(o)
	self.addRateItems[o.index] = o.itemId;
	self:updateAddRateItem();
end
function Lua_CombineEightPanel:onRemoveRateItem1(o)
	self.addRateItems[1] = 0;
	self:updateAddRateItem();
end
function Lua_CombineEightPanel:onRemoveRateItem2(o)
	self.addRateItems[2] = 0;
	self:updateAddRateItem();
end
function Lua_CombineEightPanel:onRemoveRateItem3(o)
	self.addRateItems[3] = 0;
	self:updateAddRateItem();
end
function Lua_CombineEightPanel:onRemoveRateItem4(o)
	self.addRateItems[4] = 0;
	self:updateAddRateItem();
end
function Lua_CombineEightPanel:updateAddRateItem()
	if self.data == nil then
		return;
	end

	local numDic = {};
	for k,v in pairs(self.addRateItems) do
		if numDic[v] == nil then
			numDic[v] = 0;
		end
		numDic[v] = numDic[v] + 1;
	end

	local hasItem = false;
	local rateItems = self.data.rateItem;
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	for i=1,rateItems:getSize() do
		local n = bagData:getItemNum(rateItems[i].itemId);
		local useNum = numDic[rateItems[i].itemId] == nil and 0 or numDic[rateItems[i].itemId];
		if n > useNum then
			hasItem = true;
			break;
		end
	end

	for i=1,4 do
		if self.addRateItems[i] == nil or self.addRateItems[i] == 0 then
			self["addSp"..i]:setEnable(hasItem);
		else
			self["addSp"..i]:setEnable(false);
		end
	end

	local addRate = 0;
	for i=1,4 do
		if self.addRateItems[i] == 0 then
			self.addsArr[i].data = nil;
			self.addsArr[i]:showCloseSp(false, false, "REMOVE_RATE_ITEM_"..i, "a");
			self["addLabel"..i]:setEnable(true);
		else
			local tvo = Lua_ToolVo.createToolVo(self.addRateItems[i]);
			self.addsArr[i].data = tvo;
			self.addsArr[i]:showCloseSp(true, true, "REMOVE_RATE_ITEM_"..i, "a");
			self["addLabel"..i]:setEnable(false);
			addRate = addRate + self.data:getRateItemRate(self.addRateItems[i]);
		end
	end
	addRate = addRate + self.data.rate;
	if addRate > 100 then
		addRate = 100;
	end
	self.sucessTxt.text = LanUtil.formateStr(LanUtil.getValue(110827), tostring(addRate));
end