Lua_CombineFourPanel = class("Lua_CombineFourPanel", Lua_DisplayObject);
function Lua_CombineFourPanel:ctor(p)
    self:superCall("ctor", p, "CombineFourPanel_skin");
end
function Lua_CombineFourPanel:buildShowItem()
    self:superCall("buildShowItem");
    self.oneBtn:addClickFuntion(self, self.onOneClick);
    self.combineBtn:addClickFuntion(self, self.onCombineClick);

    self.special.clickScale = false;
    self.special:addClickFuntion(self, self.onOpenSpecialTips);
    self.selectCheckBox:addBoxChange(self, self.onSelectBoxClick);

    self:addLuaEvent("PACK_HECHENG_PUINTO_EQUIP", self, self.onUpdateEquipInfo);
    self:addLuaEvent("PACK_REMOVE_EQUIP", self, self.onRemoveEquip)

    local poses = { { - 222, 150 }, { -222, -90 }, { 40, 150 }, { 40, -90 } };
    self.materlsArr = Array();
    for i, v in ipairs(poses) do
        local tvi = Lua_ToolImage.new(self.content);
        tvi:setLocation(v[1], v[2], 0);
        tvi:setDepth(4);
        tvi.content.name = i;
        tvi.isShowBtns = false;
        self.materlsArr:add(tvi);
    end

    self.mainImage = Lua_ToolImage.new(self.content);
    self.mainImage:setDepth(4);
    self.mainImage:setLocation(-90, 35, 0);
    self.mainImage.isShowBtns = false;
end
function Lua_CombineFourPanel:onPackUpdate(o)
    if self.data ~= nil then
        self:setData(self.data);
    end
end
function Lua_CombineFourPanel:dispose()
    self:superCall("dispose");
    Lua_CommonUtil.removeTimer(self, self.conbineItem);
end
function Lua_CombineFourPanel:setData(val)
    self.data = val;
    self.showAllData = nil;
    self.showData = nil;
    self.tempLeftTime = 0;
    self.sucessTxt.text = val.rate .. "%";

    if tonumber(val.rate) >= 100 and math.floor(val.type / 100) ~= 6 then
        -- 100%成功
        self.oneBtn:setEnable(true);
        self.combineBtn:setLocation(9, -278);
    else
        self.oneBtn:setEnable(false);
        self.combineBtn:setLocation(-114, -278);
    end

    local useNumDic = { };
    local materials = val.materials;
    local overNum = 0;
    local isShowLock = true
    if self.data.type == Lua_ItemCombineUtil.SHENSHOU_EQUIP_HECHENG or Lua_ItemCombineUtil.SHENSHOU_EQUIP_HECHENG2 == self.data.type then
        isShowLock = false
        self.oneBtn.label = LanUtil.getValue(110887);
    else
        isShowLock = true
        self.oneBtn.label = LanUtil.getValue(110855);
    end
    for i = 1, 4 do
        if materials[i] ~= nil then
            local itemList = DataCenter.packData:getBagType(2):getItemsById(materials[i].id);
            if itemList ~= nil and itemList:getSize() > 0 then
                for j = 1, itemList:getSize() do
                    if itemList[j].fairyVo ~= nil and itemList[j].fairyVo.expireTimes ~= nil then
                        if itemList[j].fairyVo.isUsed == 1 then
                            local leftTime = itemList[j].fairyVo.expireTimes - DataCenter.roleData.serverTime;
                            if leftTime <= 0 then
                                overNum = overNum + 1;
                            elseif self.showAllData == nil and self.tempLeftTime < leftTime then
                                self.showData = itemList[j];
                                self.tempLeftTime = leftTime;
                            end
                        elseif self.showAllData == nil then
                            self.showAllData = itemList[j];
                        end
                    end
                end
            end
            if self.showAllData ~= nil then
                self.materlsArr[i].data = self.showAllData;
            elseif self.showData ~= nil then
                self.materlsArr[i].data = self.showData;
            else
                self.materlsArr[i].data = materials[i];
            end
            self.materlsArr[i]:showCloseSp(false);
            if isShowLock == false and i ~= 1 then
                self.materlsArr[i]:showLockSlot(false, "iconantlas1", "tongyong_jiahao");
                self.materlsArr[i].lock_slot_img:removeClickFuntion(self, self.onJiaHaoClick)
            else
                self.materlsArr[i]:showLockSlot(false);
            end
            local bagNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(materials[i].id);
            if useNumDic[materials[i].id] == nil then
                useNumDic[materials[i].id] = 0;
            end
            local useNum = useNumDic[materials[i].id];
            local leftNum = bagNum - useNum - overNum;
            if leftNum < 0 then
                leftNum = 0;
            end
            self.materlsArr[i]:showNumLimit(leftNum, materials[i].count, 2);
            useNumDic[materials[i].id] = useNumDic[materials[i].id] + materials[i].count;
        else
            self.materlsArr[i].data = nil;
            self.materlsArr[i]:showCloseSp(false);
            self.materlsArr[i]:showLockSlot(true);
            if isShowLock == false and i ~= 1 then
                self.materlsArr[i]:showLockSlot(true, "iconantlas1", "tongyong_jiahao");
                self.materlsArr[i].lock_slot_img:addClickFuntion(self, self.onJiaHaoClick)
            else
                self.materlsArr[i]:showLockSlot(true);
            end
        end
    end

    local fairyList = DataCenter.fairyData.fairyList;
    local tvo = Lua_ToolVo.createToolVo(val.output);
    if val.star ~= nil then
        tvo.star = val.star
    end
    tvo.darkColor = true;
    if self.showAllData ~= nil or self.showData ~= nil then
        for i = 1, fairyList:getSize() do
            if fairyList[i].itemId == val.output then
                if tvo.fairyVo == nil then
                    tvo.fairyVo = fairyList[i];
                    tvo.fairyType = tvo.fairyVo.index;
                end
            end
        end
    end
    if self.showAllData ~= nil and tvo.fairyVo ~= nil then
        tvo.fairyVo.isUsed = 0;
        tvo.fairyVo.expireTimes = 0;
        tvo.fairyVo.validTimes = self.showAllData.fairyVo.validTimes;
        tvo.timeOut = self.showAllData.timeOut;
    elseif self.showData ~= nil and tvo.fairyVo ~= nil then
        tvo.fairyVo.isUsed = 1;
        tvo.fairyVo.expireTimes = self.showData.fairyVo.expireTimes;
        tvo.timeOut = self.showData.timeOut;
    end
    self.mainImage.data = tvo;
    self.itemNameTxt.text = tvo.colorName;

    if val.universal_item ~= nil then
        self.specialObg:SetActive(true);
        self.special:setAltas(val.universal_item.atlas, tostring(val.universal_item.id));
        self.special_text.text = val.universal_item.bagNum;
        if DataCenter.packData.isSelectBox == true then
            self.selectCheckBox.seleted = true;
        else
            self.selectCheckBox.seleted = false;
        end
    else
        self.specialObg:SetActive(false);
    end
end


function Lua_CombineFourPanel:onJiaHaoClick(go)
    self.clickIndex = tonumber(go.transform.parent.name)
    local list = { }
    local arr = Array()
    local len = self.materlsArr:getSize()
    for i = 2, len do
        if self.materlsArr[i] ~= nil and self.materlsArr[i].data ~= nil then
            arr:add(self.materlsArr[i].data.index)
        end
    end
    list.indexArr = arr
    list.star = self.data.equip[1][2]
    list.color = self.data.equip[1][1]
    Lua_WindowUtil.openWin("Lua_PackHeChengWindow", WinParam.ACTION_OPEN, list)
end
function Lua_CombineFourPanel:onUpdateEquipInfo(data)
    self.materlsArr[self.clickIndex].data = data;
    self.materlsArr[self.clickIndex]:showCloseSp(true, true, "PACK_REMOVE_EQUIP", "Lua_PackWindow", Vector3(30, 30));
    self.materlsArr[self.clickIndex]:showLockSlot(false);
end

function Lua_CombineFourPanel:onRemoveEquip(go)
    local len = self.materlsArr:getSize()
    for i = 1, len do
        if self.materlsArr[i].data == go then
            self.materlsArr[i].data = nil
            self.materlsArr[i]:showLockSlot(true, "iconantlas1", "tongyong_jiahao");
            self.materlsArr[i].lock_slot_img:addClickFuntion(self, self.onJiaHaoClick)
            self.materlsArr[i]:showCloseSp(false);
            break
        end
    end

end
function Lua_CombineFourPanel:onOneClick(go)
    if self.data == nil then
        return
    end
    if self.data.type ~= Lua_ItemCombineUtil.SHENSHOU_EQUIP_HECHENG and Lua_ItemCombineUtil.SHENSHOU_EQUIP_HECHENG2 ~= self.data.type then
        if DataCenter.packData.isSelectBox == true and self.data.universal_item ~= nil then
            Lua_PackUtil.combineItem(self.data, nil, true, self.data.universal_item, 1);
        else
            Lua_PackUtil.combineItem(self.data, nil, true);
        end
    else
        self:onePutShenShouEquip()
    end
end
function Lua_CombineFourPanel:onePutShenShouEquip()
    -- 神兽装备
    local bagData = DataCenter.packData:getBagType(Lua_PackData.SACRED_ANIMAL_BAG);
    local _arr = bagData:getBagAllData();
    local _len = _arr:getSize()
    local arr = Array()
    for i = 1, _len do
        if _arr[i].subType == Lua_PackTypeDefine.SHENSHOU_EQU and _arr[i].color == self.data.equip[1][1] and _arr[i].star == self.data.equip[1][2] then
            arr:add(_arr[i])
        end
    end
    local len = #self.data.equip + 1
    local index = 1
    local len2 = self.materlsArr:getSize()
    for i = 2, len2 do
        self.materlsArr[i].data = nil
        self.materlsArr[i]:showLockSlot(true, "iconantlas1", "tongyong_jiahao");
        self.materlsArr[i].lock_slot_img:addClickFuntion(self, self.onJiaHaoClick)
        self.materlsArr[i]:showCloseSp(false);
    end

    for i = 2, len do
        if arr[index] ~= nil then
            self.materlsArr[i].data = arr[index]
            self.materlsArr[i]:showCloseSp(true, true, "PACK_REMOVE_EQUIP", "Lua_PackWindow", Vector3(30, 30));
            self.materlsArr[i]:showLockSlot(false);
        end
        index = index + 1
    end
end
function Lua_CombineFourPanel:onCombineClick(go)
    if self.data == nil then
        return
    end
    if self.data.type ~= Lua_ItemCombineUtil.SHENSHOU_EQUIP_HECHENG and Lua_ItemCombineUtil.SHENSHOU_EQUIP_HECHENG2 ~= self.data.type then
        self:conbineItem();
    else
        local cmd = ProtoPublic_pb.Proto11400125();
        cmd.rule_id = self.data.id;
        local len = self.materlsArr:getSize()
        for i = 2, len do
            if self.materlsArr[i].data ~= nil then
                cmd.material_index:append(self.materlsArr[i].data.index);
            end
        end
        sendMsg(11400125, cmd)
    end
end
function Lua_CombineFourPanel:startOneConbine()
    if self.isRunning == nil or self.isRunning == false then
        self.isRunning = true;
        self.oneBtn.label = LanUtil.getValue(110856);
        Lua_CommonUtil.addTimer("startOneConbine", 1, self, self.conbineItem);
    end
end
function Lua_CombineFourPanel:stopOneConbine()
    if self.isRunning == true then
        self.isRunning = false;
        self.oneBtn.label = LanUtil.getValue(110855);
        Lua_CommonUtil.removeTimer(self, self.conbineItem);
    end
end
function Lua_CombineFourPanel:setEnable(val)
    self.data = nil;
    if val == false then
        self:stopOneConbine();
    end
    self:superCall("setEnable", val);
end
function Lua_CombineFourPanel:dispose()
    self:stopOneConbine();
    self:superCall("dispose");
end
function Lua_CombineFourPanel:conbineItem()
    if math.floor(self.data.type / 100) == 6 then
        self.tempTime = 0;
        self.allTime = 0;
        self.isAllTime = false;
        for i = 1, 4 do
            if self.data.materials[i] ~= nil then
                local itemList = DataCenter.packData:getBagType(2):getItemsById(self.data.materials[i].id);
                if itemList ~= nil then
                    for j = 1, itemList:getSize() do
                        if itemList[j].fairyVo ~= nil and itemList[j].fairyVo.expireTimes ~= nil then
                            if itemList[j].fairyVo.isUsed == 1 then
                                local leftTime = itemList[j].fairyVo.expireTimes - DataCenter.roleData.serverTime;
                                if leftTime > 0 and tonumber(itemList[j].fairyVo.expireTimes) > self.tempTime then
                                    self.tempTime = tonumber(itemList[j].fairyVo.expireTimes);
                                    self.allTime = tonumber(itemList[j].fairyVo.validTimes);
                                end
                            else
                                self.isAllTime = true;
                            end
                        end
                    end
                end
            end
        end

        if self.tempTime > 0 then
            local timeOut = math.ceil((self.tempTime - DataCenter.roleData.serverTime) / 86400);
            local compTime = math.ceil(self.allTime / 86400);
            if timeOut < compTime and self.isAllTime == false then
                local tipData = { };
                tipData.des = LanUtil.formateStr(LanUtil.getValue(140601), tostring(timeOut));
                tipData.showHint = LanUtil.getValue(140602)
                tipData.owner = self;
                tipData.type = 1;
                tipData.subFun = self.getCombine;
                Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
                return;
            end
        end
    end
    self:getCombine();
end
function Lua_CombineFourPanel:getCombine()
    local rs;
    if DataCenter.packData.isSelectBox == true and self.data.universal_item ~= nil then
        Lua_PackUtil.combineItem(self.data, nil, nil, self.data.universal_item, 1);
    else
        rs = Lua_PackUtil.combineItem(self.data);
    end

    if rs == false then
        self:stopOneConbine();
    end
end

function Lua_CombineFourPanel:onSelectBoxClick(state)
    -- 隐藏
    if state == true then
        DataCenter.packData.isSelectBox = true;
    else
        DataCenter.packData.isSelectBox = nil;
    end
    DataCenter.combineUtil:checkCombineRedDot();
end

function Lua_CombineFourPanel:onOpenSpecialTips()
    -- 魂石Tips
    Lua_PackUtil.showItemInfo(self.data.universal_item, false)
end