Lua_CombineListItem = class("Lua_CombineListItem", Lua_ListCell);
function Lua_CombineListItem:ctor(p)
	self:superCall("ctor", p, "CombineListItem_skin");
end

function Lua_CombineListItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(5);
	self.itemImg:setLocation(-89, 5, 0);

	self.redDotImg:setEnable(false);
end

function Lua_CombineListItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local tvo = Lua_ToolVo.createToolVo(data.output);
	tvo.darkColor = true;
	tvo.star = data.star ~= nil and data.star or nil;
	self.itemImg.data = tvo;
	self.itemTxt.text = tvo.colorName;

	local had_Count = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(data.output);
	if self._data.type == Lua_ItemCombineUtil.SHENSHOU_EQUIP_HECHENG or self._data.type == Lua_ItemCombineUtil.SHENSHOU_EQUIP_HECHENG2 then
		local ItemArr = DataCenter.packData:getBagType(Lua_PackData.SACRED_ANIMAL_BAG):getBagAllData();
		local count = 0;
		for i = 1, ItemArr:getSize() do
			if ItemArr[i].id == data.output and ItemArr[i].star == data.star then
				count = count + 1;
			end
		end
		had_Count = count;
	end
	self.numTxt.text = LanUtil.formateStr(LanUtil.getValue(110826), tostring(had_Count));

	if data.selected == true then
		self.bg:setAltas("common_atlas_1", "ui_common_widget_p2");
	else
		self.bg:setAltas("common_atlas_1", "ui_common_widget_p1");
	end

	self.selectBg:setEnable(data.selected);
	self.redDotImg:setEnable(self._data.redDotState);
end

function Lua_CombineListItem:onPlayerSoundClick(go)
	DataCenter.combineUtil.selectIndex = self._data.selectIndex;
	Lua_MsgUtil.callFunc("COMBINE_ITEM_SELECTED", self._data);
end