checkRequire("Lua_PackCellsItem");
checkRequire("Lua_WhareCellsItem");
Lua_PackItemListContainer = class("Lua_PackItemListContainer", Lua_DisplayObject);
function Lua_PackItemListContainer:ctor(p, type, pagePosx, pagePosy, pageLen)
	self.type = type;
	self.pagePosx = pagePosx;
	self.pagePosy = pagePosy;
	self.pageLen = pageLen;
	self.salePanelShow = false;
	self:superCall("ctor", p);
end

function Lua_PackItemListContainer:buildShowItem()
	self:superCall("buildShowItem");

	local pageSp;
	local perWidth = 28;
	self.pageTipList = Array();
	for i = 1, self.pageLen do
		pageSp = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_b_1", 0, 0, 0, 0);
		pageSp.name = i;
		pageSp:setDepth(5);
		pageSp:addClickFuntion(self, self.onPageClick);
		pageSp:setLocation(-perWidth * self.pageLen / 2 + perWidth * (i - 1) + perWidth / 2 + self.pagePosx, self.pagePosy, 0);
		self.pageTipList:add(pageSp);
	end

	if self.type == Lua_PackData.BAG_PACK then
		self.dragList = Lua_DragList.new(self.content, 2, Vector4(0, 0, 460, 450));
		self.dragList:setListCell(Lua_PackCellsItem, 450, 480, 1000);
		self.dragList:setCellScaleChange(true, 1, 1, 480, self, self.onPageCallBack);

	else
		self.dragList = Lua_DragList.new(self.content, 2, Vector4(0, 0, 550, 450));
		self.dragList:setListCell(Lua_WhareCellsItem, 450, 570, 1000);
		self.dragList:setCellScaleChange(true, 1, 1, 570, self, self.onPageCallBack);
	end
	self.dragList:setLocation(0, 0, 0);

	self:updateData();
	self.dragList:moveToIndex(1, true);
end

function Lua_PackItemListContainer:updateData()
	local arr = Array();
	if self.type == Lua_PackData.BAG_PACK then
		for i = 1, self.pageLen do
			arr:add({page = i, startIndex = (i - 1) * 25});
		end
	else
		for i = 1, self.pageLen do
			arr:add({page = i, startIndex = (i - 1) * 30});
		end
	end
	self.dragList:setLuaArrayData(arr);
end

function Lua_PackItemListContainer:onPageCallBack(index)
	for i = 1, self.pageTipList:getSize() do
		if i == index then
			self.pageTipList[i]:setAltas("common_atlas_1", "ui_common_b_2");
		else
			self.pageTipList[i]:setAltas("common_atlas_1", "ui_common_b_1");
		end
	end
end

function Lua_PackItemListContainer:onPageClick(go)
	self.dragList:moveToIndex(tonumber(go.name));
end