Lua_WhareCellsItem = class("Lua_WhareCellsItem", Lua_ListCell);
function Lua_WhareCellsItem:buildShowItem()
	self:superCall("buildShowItem");
	self.lastClickIndex = -1;
	self.lastClickTime = 0;
	self.cellPosX = {{-265, -185}, {-175,-95}, {-85, -5}, {5, 85}, {95,175}, {185, 265}};
	self.cellPosY = {{140,220}, {50,130}, {-40, 40}, {-130,-50}, {-220,-140}};
	self.cells = Array();
	local cellSize = 30;
	local perWidth = 90;
	local perHeight = 90;
	for i=1,cellSize do
		local c = Lua_ToolImage.new(self.content);
		local px = (i - 1) % 6;
		local py = math.ceil(i / 6);
		c.defaultRoundEffect = true;
		c:setLocation(- 1 * perWidth * 6 / 2 + px * perWidth + perWidth / 2, perHeight / 2 + perHeight * 5 / 2  - perHeight * py, 0);
		c:setDepth(3);
		c:setCanClick(false);
		c.content.name = "c"..i;
		self.cells:add(c);
	end
end
function Lua_WhareCellsItem:checkOutBound(showRect)
	local len = self.cells:getSize();
	for i=1,len do
		if self.cells[i].data ~= nil then
			local rect = Lua_Rectangle.new(self.itemX + self.cells[i].x - 40, self.itemY + self.cells[i].y - 40, 80,80);
			if showRect:containeRect(rect) == true then
				self.cells[i]:showRoundEffectView(true);
			else
				self.cells[i]:showRoundEffectView(false);
			end
		end
	end
end
function Lua_WhareCellsItem:dispose()
	self:superCall("dispose");
	Lua_CommonUtil.removeTimer(self, self.onSingleClick);
end
function Lua_WhareCellsItem:setData(data)
	local st = data.startIndex;
	self.startIndex = st;
	local len = self.cells:getSize();
	local bagData = DataCenter.packData:getBagType(Lua_PackData.WHARE);
	local packSize = bagData.packSize == nil and 30 or bagData.packSize;
	for i=1,len do
		local curIndex = st + i - 1;
		self.cells[i].curIndex = self.cells[i];
		local td = bagData:getItemByIndex(curIndex);
		if curIndex >= packSize and td == nil then--没开锁
			self.cells[i].data = nil;
			self.cells[i]:showLockSlot(true);
		else
			self.cells[i]:showLockSlot(false);
			self.cells[i].data = td;
		end
	end
end
function Lua_WhareCellsItem:onPlayerSoundClick()
	local v = Vector3(UnityEngine.Input.mousePosition.x,UnityEngine.Input.mousePosition.y,0);
	local screenpos = UICamera.mainCamera:ScreenToWorldPoint(v);
	local mousePosition = self.content.transform:InverseTransformPoint(screenpos);

	local cx = 0;
	for i,v in ipairs(self.cellPosX) do
		if v[1] <= mousePosition.x and v[2] > mousePosition.x then
			cx = i;
			break;
		end
	end
	if cx == 0 then
		return;
	end
	local cy = 0;
	for i,v in ipairs(self.cellPosY) do
		if v[1] <= mousePosition.y and v[2] > mousePosition.y then
			cy = i;
			break;
		end
	end
	if cy == 0 then
		return;
	end
	self.clickIndex = cx + (cy - 1) * 6;
	--self:onSingleClick();
	if self.lastClickIndex ~= self.clickIndex or getTime() - self.lastClickTime > 0.3 then
		self.lastClickTime = getTime();
		self.lastClickIndex = self.clickIndex;
		Lua_CommonUtil.delayCall(0.3, self, self.onSingleClick);
	else
		Lua_CommonUtil.removeTimer(self, self.onSingleClick);
		self:onDoubleClick();
		self.lastClickTime = -1;
	end
end 
function Lua_WhareCellsItem:onDoubleClick()
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	local tvo = self.cells[self.clickIndex].data;
	if tvo == nil then
		return;
	end
	Lua_PackUtil.toPack(tvo);
end
function Lua_WhareCellsItem:onSingleClick()
	local totalIndex = self.clickIndex + (self.cellSeqIndex - 1) * 30;
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	local packSize = bagData.packSize;
	if totalIndex <= packSize then
		if self.cells[self.clickIndex] ~= nil and self.cells[self.clickIndex].data ~= nil then
			Lua_PackUtil.showItemInfo(self.cells[self.clickIndex].data);
		end
	end
end