-- 命锁移动方块
checkRequire("Lua_MingSuoItemModel");
Lua_MingSuoDragWindow = class("Lua_MingSuoDragWindow", Lua_Window);
function Lua_MingSuoDragWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_MingSuoDragWindow";
	self.layer = 6500;
	self.blackAlpha = 0.01;
	self.showClose = false;
end

function Lua_MingSuoDragWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.model = Lua_MingSuoItemModel.new(self.content)
end

function Lua_MingSuoDragWindow:showWin(param)
	self:superCall("showWin", param);

	self.model:setData(param);
	self.model:setIconSprite();
	self.model:setIconAlpha(0.5);

	Lua_CommonUtil.addTimer("Lua_MingSuoDragWindow", 0.001, self, self.onModelMoving);
	self:onModelMoving();
end

function Lua_MingSuoDragWindow:onModelMoving()
	local pos = Vector3(UnityEngine.Input.mousePosition.x, UnityEngine.Input.mousePosition.y, 0);
	local screenpos = UICamera.mainCamera:ScreenToWorldPoint(pos);
	local mousePosition = self.content.transform:InverseTransformPoint(screenpos);
	self.model:setLocation(mousePosition.x + self.showData.offset_pos[1], mousePosition.y + self.showData.offset_pos[2]);
end

function Lua_MingSuoDragWindow:dispose()
	local pos = Vector3(UnityEngine.Input.mousePosition.x, UnityEngine.Input.mousePosition.y, 0);
	local screenpos = UICamera.mainCamera:ScreenToWorldPoint(pos);
	Lua_MsgUtil.callFunc("MING_SUO_DROP", {modelData = self.showData, screenpos = screenpos});
	Lua_CommonUtil.removeTimer(self, self.onModelMoving);

	self:superCall("dispose");
end