﻿Lua_MingSuoInfoWindow = class("Lua_MingSuoInfoWindow", Lua_Window);
function Lua_MingSuoInfoWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_MingSuoInfoWindow";
	self.skinName = "MingSuoInfoWindow_skin";
	self.blackAlpha = 1 / 255;
	self.showClose = false;
	self.isClickClose = true;
end

function Lua_MingSuoInfoWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.floorTxt.text = LanUtil.formateStr(LanUtil.getValue(128804), tostring(DataCenter.mingSuoData.curFloor), tostring(DataCenter.mingSuoData.totalFloors))

	local attrDic = self:getToltalAttr();
	self.powerTxt.text = Lua_FightUtil.caculateConfigForce(attrDic);

	local arr = Array();
	for k, v in pairs(attrDic) do
		arr:add({
			attrName = Lua_ThingDefine.getParamName(k),
			rank = Lua_ThingDefine.getParaRankByParams(k),
			value = v
		})
	end
	arr:sort("rank", false);

	self.desList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 272, 196));
	self.desList:setListCell(Lua_MingSuoInfoItem, 30, 10, 1);
	self.desList:setLocation(-74, -120, 0);
	self.desList:setLuaArrayData(arr, false);
end

function Lua_MingSuoInfoWindow:getToltalAttr()
	local floorArr = DataCenter.mingSuoData.floorArr;
	local floorShow;
	local attrDic = {};
	for i = 1, floorArr:getSize() do
		floorShow = floorArr[i].floor_show
		for i = 1, floorShow:getSize() do
			if floorShow[i].value ~= 0 and floorShow[i].is_insert ~= 0 then
				if attrDic[floorShow[i].attr] == nil then
					attrDic[floorShow[i].attr] = floorShow[i].value;
				else
					attrDic[floorShow[i].attr] = attrDic[floorShow[i].attr] + floorShow[i].value;
				end
			end
		end
	end
	return attrDic;
end

function Lua_MingSuoInfoWindow:dispose()
	if self.desList ~= nil then
		self.desList:dispose();
		self.desList = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_MingSuoInfoItem = class("Lua_MingSuoInfoItem", Lua_ListCell);
function Lua_MingSuoInfoItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_MingSuoInfoItem:buildShowItem()
	self:superCall("buildShowItem");

	self.showItem = Lua_ShowItem.new(self.content);
	self.showItem:setLocation(0, 0, 0);
end

function Lua_MingSuoInfoItem:setData(data)
	self._data = data;

	self.showItem:setAttrTxt(22, 22, LanUtil.formateStr(LanUtil.getValue(128803), data.attrName), data.value, -7);
end 

function Lua_MingSuoInfoItem:dispose()
	if self.showItem ~= nil then
		self.showItem:dispose();
		self.showItem = nil;
	end
	self:superCall("dispose");
end