Lua_MingSuoItem = class("Lua_MingSuoItem", Lua_DisplayObject);
function Lua_MingSuoItem:ctor(p)
	self:superCall("ctor", p, "MingSuoItem_skin");
end

function Lua_MingSuoItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_MingSuoItem:setData(data, canClick)
	self._data = data;

	self.itemBg:setAltas(self._data.atlasName, self._data.iconName);

	if self._data.value == 0 then
		self.attrTxt.text = "";
		self.numTxt.text = "";
	else
		if self._data.is_insert ~= 0 then
			self.attrTxt.text = self._data.attrName;
			self.numTxt.text = self._data.value;
		else
			self.attrTxt.text = "[A4A4BD]" .. self._data.attrName .. "[-]";
			self.numTxt.text = "[A4A4BD]" .. self._data.value .. "[-]";
		end
	end
	self.itemBg.mainContent.name = self._data.is_insert;
	self:onRemoveFun(canClick)
end

function Lua_MingSuoItem:onItemClick(go)
	self.startX = UnityEngine.Input.mousePosition.x;
	self.startY = UnityEngine.Input.mousePosition.y;
	self.isMouseDown = true;
	self.startClickTime = getTime();
	Lua_CommonUtil.addTimer("onMingSuoItemMoving", 0.01, self, self.onMingSuoItemMoving);
end

function Lua_MingSuoItem:onMouseUp()
	self.isMouseDown = false;
	Lua_WindowUtil.openWin("Lua_MingSuoDragWindow", WinParam.ACTION_CLOSE);
	Lua_CommonUtil.removeTimer(self, self.onMingSuoItemMoving);
end

function Lua_MingSuoItem:onSetDepth(value)
	self.itemBg:setDepth(value);
	self.attrTxt:setDepth(value + 1);
	self.numTxt:setDepth(value + 1);
end

function Lua_MingSuoItem:onRemoveFun(value)
	if value == true then
		self.itemBg:addClickFuntion(self, self.onItemClick);
		self.itemBg:addMouseUpFuntion(self, self.onMouseUp);
	else
		self.itemBg:removeClickFuntion(self, self.onItemClick)
		self.itemBg:removeClickFuntion(self, self.onMouseUp);
	end
end


function Lua_MingSuoItem:onMingSuoItemMoving()
	local lx = math.abs(UnityEngine.Input.mousePosition.x - self.startX);
	local ly = math.abs(UnityEngine.Input.mousePosition.y - self.startY);
	if self.isMouseDown == true and lx + ly < 3 and getTime() - self.startClickTime > 0 then
		local data = DataCenter.mingSuoData.curFloorArr:getModelById(self._data.is_insert)
		Lua_WindowUtil.openWin("Lua_MingSuoDragWindow", WinParam.ACTION_OPEN, data);
		Lua_MsgUtil.callFunc("MING_SUO_MOVING", self._data.is_insert)
		Lua_CommonUtil.removeTimer(self, self.onMingSuoItemMoving);
	end
end