Lua_MingSuoItemModel = class("Lua_MingSuoItemModel", Lua_DisplayObject);
function Lua_MingSuoItemModel:ctor(p, imgScale)
	self:superCall("ctor", p);
	self.imgScale = imgScale == nil and 55 or imgScale
end

function Lua_MingSuoItemModel:buildShowItem()
	self:superCall("buildShowItem");

	self.list = Array();
	self.content.name = "Lua_MingSuoItemModel";
end

function Lua_MingSuoItemModel:setData(data, canMouseClick)
	self.data = data;

	if self.list:getSize() > 0 then
		self.list:dispose();
		self.list:clear();
	end

	local icon;
	local boxCollider;
	for i = 1, #data.indexArr do
		icon = UICreate.createUIAtlasImage(self.content, "packWindow", data.uiName, 0, 0, self.imgScale, self.imgScale);
		icon.name = i;
		icon.clickScale = false;
		icon:setDepth(4);
		icon:setEnable(true);
		icon:setLocation(data.indexArr[i][1] * (self.imgScale + 1), data.indexArr[i][2] * (self.imgScale + 1));
		if canMouseClick == true then
			icon:addClickFuntion(self, self.onItemClick);
			icon:addMouseUpFuntion(self, self.onMouseUp);
		end
		
		boxCollider = icon.mainContent:GetComponent("BoxCollider");
		if boxCollider ~= nil then
			boxCollider.isTrigger = true;
			boxCollider.center = Vector3(0, 0, 0);
			boxCollider.size = Vector3(55, 55, 0);
		end
		self.list:add(icon);
	end
end

function Lua_MingSuoItemModel:onItemClick(go)
	self.startX = UnityEngine.Input.mousePosition.x;
	self.startY = UnityEngine.Input.mousePosition.y;

	self.isMouseDown = true;
	self.startClickTime = getTime();
	Lua_CommonUtil.addTimer("Lua_MingSuoItemModel", 0.01, self, self.onCheckMoving);
end

function Lua_MingSuoItemModel:onCheckMoving()
	local lx = math.abs(UnityEngine.Input.mousePosition.x - self.startX);
	local ly = math.abs(UnityEngine.Input.mousePosition.y - self.startY);
	if self.isMouseDown == true and lx + ly < 3 and getTime() - self.startClickTime > 0 then
		self:setModelAltas("ui_knapsack_icon_c");
		
		Lua_WindowUtil.openWin("Lua_MingSuoDragWindow", WinParam.ACTION_OPEN, self.data);
		Lua_CommonUtil.removeTimer(self, self.onCheckMoving);
	end
end

function Lua_MingSuoItemModel:setIconSprite()
	for i = 1, self.list:getSize() do
		self.list[i]:setAltas("packWindow", self.data.initUiName);
	end
end

function Lua_MingSuoItemModel:setModelAltas(spriteName)
	for i = 1, self.list:getSize() do
		self.list[i]:setAltas("packWindow", spriteName);
	end
end

function Lua_MingSuoItemModel:onMouseUp(go)
	self.isMouseDown = false;
	Lua_WindowUtil.openWin("Lua_MingSuoDragWindow", WinParam.ACTION_CLOSE);
	Lua_CommonUtil.removeTimer(self, self.onCheckMoving);
end

function Lua_MingSuoItemModel:setDepth(val)
	for i = 1, self.list:getSize() do
		self.list[i]:setDepth(val);
	end
end

function Lua_MingSuoItemModel:setIconAlpha(val)
	for i = 1, self.list:getSize() do
		self.list[i].uiwidget.color = Color.New(1, 1, 1, val);
	end
end

function Lua_MingSuoItemModel:dispose()
	if self.list ~= nil then
		self.list:dispose();
		self.list:clear();
		self.list = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.onCheckMoving);

	self:superCall("dispose");
end