checkRequire("Lua_MingSuoItemModel");
Lua_MingSuoItemModelWithButton = class("Lua_MingSuoItemModelWithButton", Lua_DisplayObject);
function Lua_MingSuoItemModelWithButton:ctor(p, modelId)
	self:superCall("ctor", p, "MingSuoItemModelWithButton_skin");
	self.modelId = modelId;
end

function Lua_MingSuoItemModelWithButton:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg.data = Lua_ToolVo.new(Lua_MingSuoData.ITEM_ID);
	self.itemImg:setDepth(5);
	self.itemImg:showItemBg(false);
	self.itemImg:setCanClick(true);
	self.itemImg:setLocation(-20, -60);
	self.itemImg:setScale(0.3, 0.3);

	self.redDot = UICreate.createUIAtlasImage(self.button.mainContent, "common_atlas_1", "ui_common_hongdian", 56, 18, 0, 0);
	self.redDot.name = "redDot";
	self.redDot:setDepth(6);
	self.redDot:setEnable(false);

	self.model = Lua_MingSuoItemModel.new(self.content, 27);

	self.button:addClickFuntion(self, self.onBtnClick);
end

function Lua_MingSuoItemModelWithButton:setData(data, canMouseClick)
	self.data = data;

	self.label.text = data.modelCost;
	self.model:setData(data, canMouseClick);
	self.model:setLocation(data.model_fangkuai_pos[1], data.model_fangkuai_pos[2]);

	self:onRedDotShow();
end

function Lua_MingSuoItemModelWithButton:onRedDotShow()
	self.button:setEnable(self.data.is_activate ~= 1)
	self.label:setEnable(self.data.is_activate ~= 1)
	self.itemImg:setEnable(self.data.is_activate ~= 1)

	local state = DataCenter.mingSuoData.life_power >= self.data.modelCost and self.data.is_activate ~= 1;
	self.redDot:setEnable(state);
end

function Lua_MingSuoItemModelWithButton:onBtnClick()
	Lua_ProxyManager.getProxy("Lua_MingSuoProxy"):sJiHuoMsg(DataCenter.mingSuoData.curFloor, self.modelId);
end

function Lua_MingSuoItemModelWithButton:dispose()
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end
	if self.redDot ~= nil then
		self.redDot:dispose();
		self.redDot = nil;
	end
	if self.model ~= nil then
		self.model:dispose();
		self.model = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end