﻿checkRequire("Lua_MingSuoItem");
checkRequire("Lua_MingSuoFloorItem");
checkRequire("Lua_MingSuoItemModelWithButton");
Lua_MingSuoPanel = class("Lua_MingSuoPanel", Lua_DisplayObject);
function Lua_MingSuoPanel:ctor(p)
	self:superCall("ctor", p, "MingSuoPanel_skin");
end

function Lua_MingSuoPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.modelList = {};
	self.resetTxt.text = LanUtil.getValue(128809);
	self.resetObj:SetActive(false);
	self.clickBtn:setEnable(false);
	self.passedObj:SetActive(false);

	self.mask.clickScale = false;
	self.mask.alpha = 0.01;
	self.mask:setEnable(false);

	self.mingSuoItem = Lua_ToolImage.new(self.content);
	self.mingSuoItem.data = Lua_ToolVo.new(Lua_MingSuoData.ITEM_ID);
	self.mingSuoItem:setDepth(5);
	self.mingSuoItem:showItemBg(false);
	self.mingSuoItem:setCanClick(true);
	self.mingSuoItem:setScale(0.7, 0.7);
	self.mingSuoItem:setLocation(350, 255);

	self.floorItem = Lua_MingSuoFloorItem.new(self.content);

	self.mask:addClickFuntion(self, self.onImgClick);
	self.mingSuoAttrBtn:addClickFuntion(self, self.shuXingClick);
	self.leftBtn:addClickFuntion(self, self.onLeftClick);
	self.rightBtn:addClickFuntion(self, self.onRightClick);
	self.clickBtn:addClickFuntion(self, self.onPassClick);
	self.resetBtn:addClickFuntion(self, self.onResetBtnClick);
	self.shareBtn:addClickFuntion(self, self.onShareClick);
	self.ruleBtn:addClickFuntion(self, self.onHelpClick);

	self:onCreateAnimUI();

	self:addLuaEvent("UPDATE_MINGSUO_PANEL", self, self.updateMingSuoPanelInfo);
	self:addLuaEvent("PLAY_ANIMATION_MINGSUO", self, self.onPlayAnim);
	self:initMingSuoInfo(0);
end

function Lua_MingSuoPanel:onCreateAnimUI()
	if self.emptyGo == nil then
		self.emptyGo = UICreate.createGameObject(self.content, 0, 0, 0);

		self.maskPanel = self.emptyGo:AddComponent(typeof(UIPanel));
		self.maskPanel.clipping = UIDrawCall.Clipping.SoftClip;
		self.maskPanel.clipOffset = Vector2(0, 0);
		self.maskPanel.clipSoftness = Vector2(2, 2);
		self.maskPanel.baseClipRegion = Vector4(-54, 35, 1150, 402);
		self.maskPanel.renderQueue = UIPanel.RenderQueue.StartAt;
		self.maskPanel.startingRenderQueue = 3520;
		self.maskPanel.widgetsAreStatic = false;
		self.maskPanel.anchorOffset = false;
		self.maskPanel.depth = 3520;

		local bgPath = "/images/pack/ui_knapsack_bg4.png";
		self.upMaskImg = UICreate.createImage(self.emptyGo.gameObject, bgPath, -63, 330, 0, 0);
		self.upMaskImg.name = "upMaskImg";
		self.upMaskImg.clickScale = false;
		self.upMaskImg:setDepth(6);
		self.upMaskImg:addClickFuntion(self, self.onImgClick);

		local bgPath2 = "/images/pack/ui_knapsack_bg5.png";
		self.downMaskImg = UICreate.createImage(self.emptyGo.gameObject, bgPath2, -63, -260, 0, 0);
		self.downMaskImg.name = "downMaskImg";
		self.downMaskImg.clickScale = false;
		self.downMaskImg:setDepth(6);
		self.downMaskImg:addClickFuntion(self, self.onImgClick);
	end
end

function Lua_MingSuoPanel:updateMingSuoPanelInfo()
	self.iconTxt.text = DataCenter.mingSuoData.life_power; -- LanUtil.getValue(128810)

	if DataCenter.mingSuoData.curFloor ~= nil then
		self.curIndex = DataCenter.mingSuoData.curFloor;
	end
	self:onSetListData();
end

function Lua_MingSuoPanel:onSetListData()
	self.data = DataCenter.mingSuoData.curFloorArr; -- 当前关卡信息
	self.floorItem:setFloorData(self.data);
	self.floorItem:setLocation(self.data.map_pos[1], self.data.map_pos[2]);

	self:onUpdateLVShow();
end

-- 更新关卡显示
function Lua_MingSuoPanel:onUpdateLVShow()
	self.floorTxt.text = self.data.floor_name;

	for i = 1, #self.modelList do
		self.modelList[i]:dispose();
		self.modelList[i] = nil;
	end

	local model;
	local arr = self.data.model_show;
	for i = 1, arr:getSize() do
		model = Lua_MingSuoItemModelWithButton.new(self.content, arr[i].modelIndex);
		model.content.name = "Lua_MingSuoItemModelWithButton" .. i;
		model:setLocation(arr[i].modelPos[1], arr[i].modelPos[2]);
		model:setData(arr[i], arr[i].canClick);
		model:setEnable(self.data.isLocked == false and self.data.is_reset == 1);
		self.modelList[i] = model;
	end

	self.resetObj:SetActive(self.data.is_reset == 0);
	self.passedObj:SetActive(self.data.is_hurdle == 1 or self.data.is_hurdle == 2);

	self.clickBtn:setEnable(self.data.floor_cost ~= nil);
	if self.data.is_hurdle == 1 or self.data.is_hurdle == 2 or self.curIndex > DataCenter.mingSuoData.present_hurdle then
		self.clickBtn:setEnable(false);
	end
end

function Lua_MingSuoPanel:onPlayAnim(msg)
	self.topPosY = 201;
	self.downPosY = -134;
	self.upMaskPosY = 330;
	self.downMaskPosY = -260;
	self.isFirst = true;
	self.countTime = 2;
	self.hurdle_id = self.curIndex;
	
	if WindowMananger.getInstance():isWindowShowing("Lua_MingSuoDragWindow") == true then
		Lua_WindowUtil.openWin("Lua_MingSuoDragWindow", WinParam.ACTION_CLOSE);
	end

	-- 1通关播放动画
	if msg.is_hurdle == 1 then
		self.mask:setEnable(true);
		self.hurdle_id = msg.hurdle_id;
		DataCenter.mingSuoData.curFloor = self.hurdle_id;
		
		self:initMingSuoInfo(self.hurdle_id);
		Lua_CommonUtil.delayCall(1, self, self.onAddAnima);
	end
end

function Lua_MingSuoPanel:onAddAnima()
	self.floorItem:onSetDepth(2);
	self.leftBtn:removeClickFuntion(self, self.onLeftClick);
	self.rightBtn:removeClickFuntion(self, self.onRightClick);
	Lua_CommonUtil.addTimer("onPlayAnimation", 0.001, self, self.onPlayAnimation);
end

function Lua_MingSuoPanel:onPlayAnimation()
	if self.isFirst == true then
		self.topPosY = self.topPosY - 20;
		self.upMaskPosY = self.upMaskPosY - 20;
		self.downPosY = self.downPosY + 20;
		self.downMaskPosY = self.downMaskPosY + 20;
	else
		self.topPosY = self.topPosY + 20;
		self.upMaskPosY = self.upMaskPosY + 20;
		self.downPosY = self.downPosY - 20;
		self.downMaskPosY = self.downMaskPosY - 20;
	end

	if self.isFirst == true then
		if self.topPosY <= 38 then
			self.topPosY = 38;
			Lua_CommonUtil.removeTimer(self, self.onPlayAnimation);
			Lua_CommonUtil.addTimer("onCountTimeDown", 1, self, self.onCountTimeDown);
		end

		if self.downPosY >= 27 then
			self.downPosY = 27
		end
	else
		if self.topPosY >= 201 then
			self.topPosY = 201;
			self.mask:setEnable(false);

			if self.effect ~= nil then
				self.effect:setEnable(false);
			end
			if self.effectFox ~= nil then
				self.effectFox:setEnable(false);
			end
			Lua_CommonUtil.removeTimer(self, self.onPlayAnimation);

			self.leftBtn:addClickFuntion(self, self.onLeftClick);
			self.rightBtn:addClickFuntion(self, self.onRightClick);
		end

		if self.downPosY <= -134 then
			self.downPosY = -134;
		end
	end
	self.topImg:setLocation(-63, self.topPosY, 0);
	self.downImg:setLocation(-63, self.downPosY, 0);
	self.upMaskImg:setLocation(-63, self.upMaskPosY, 0);
	self.downMaskImg:setLocation(-63, self.downMaskPosY, 0);
end

function Lua_MingSuoPanel:onCountTimeDown()
	self:playEffect();

	self.countTime = self.countTime - 1;
	if self.countTime <= 0 then
		self.countTime = 0;
		self.isFirst = false;

		if self.hurdle_id + 1 <= DataCenter.mingSuoData.totalFloors then
			DataCenter.mingSuoData.curFloor = self.hurdle_id + 1;
			self:initMingSuoInfo(self.hurdle_id + 1);
		end
		self:onAddAnima();
		Lua_CommonUtil.removeTimer(self, self.onCountTimeDown);
	end
end

function Lua_MingSuoPanel:playEffect()
	if self.effect == nil then
		self.effect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_mingsuokaiqi", "gui_mingsuokaiqi", -45, -50);
		self.effect:SetRenderQueue(self.topImg, 10, 2, false);
	end
	self.effect:setEnable(false);
	self.effect:setEnable(true);

	if self.effectFox == nil then
		self.effectFox = UICreate.createUIEffect(self.topImg.mainContent, "/effects/scsEffects/gui_fox_eye", "gui_fox_eye", -15, -5);
		self.effectFox:SetRenderQueue(self.topImg, 10, 2, false);
	end
	self.effectFox:setEnable(false);
	self.effectFox:setEnable(true);
end

function Lua_MingSuoPanel:initMingSuoInfo(index)
	Lua_ProxyManager.getProxy("Lua_MingSuoProxy"):sinitMsg(index);
end

function Lua_MingSuoPanel:onImgClick()
end

function Lua_MingSuoPanel:shuXingClick()
	if self.data == nil then
		return;
	end
	Lua_WindowUtil.openWin("Lua_MingSuoInfoWindow", WinParam.ACTION_OPEN);
end

function Lua_MingSuoPanel:onLeftClick()
	if self.data == nil then
		return;
	end

	self.curIndex = self.curIndex - 1;
	if self.curIndex <= 0 then
		self.curIndex = 1;
		OperateAlert.show(LanUtil.getValue(128801));
		return;
	end
	DataCenter.mingSuoData.curFloor = self.curIndex;
	self:initMingSuoInfo(self.curIndex);
end

function Lua_MingSuoPanel:onRightClick()
	if self.data == nil then
		return;
	end

	self.curIndex = self.curIndex + 1
	if self.curIndex > DataCenter.mingSuoData.totalFloors then
		self.curIndex = DataCenter.mingSuoData.totalFloors;
		OperateAlert.show(LanUtil.getValue(128802));
		return;
	end
	DataCenter.mingSuoData.curFloor = self.curIndex;
	self:initMingSuoInfo(self.curIndex);
end

function Lua_MingSuoPanel:onPassClick()
	if self.data == nil then
		return;
	end

	local tipData = {};
	local cost = self.data.modelTotalCost
	local cost_yuanbao = self.data.floor_cost
	if cost ~= 0 then
		tipData.des = LanUtil.formateStr(LanUtil.getValue(128808), tostring(cost_yuanbao), tostring(cost));
	else
		tipData.des = LanUtil.formateStr(LanUtil.getValue(128807), tostring(cost_yuanbao));
	end
	tipData.txtFontSize = 22;
	tipData.owner = self;
	tipData.type = 1;
	tipData.subFun = self.onSubClick;
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
end

function Lua_MingSuoPanel:onSubClick()
	Lua_ProxyManager.getProxy("Lua_MingSuoProxy"):sPassMsg(self.curIndex);
end

function Lua_MingSuoPanel:onResetBtnClick()
	if self.data == nil then
		return;
	end
	Lua_ProxyManager.getProxy("Lua_MingSuoProxy"):sReSetMsg(self.curIndex);
end

function Lua_MingSuoPanel:onShareClick()
	if self.data == nil then
		return;
	end

	local shareData = self.data:getChatShowData();
	DataCenter.chatData:setChatShowItem(2, shareData);
	OperateAlert.show(LanUtil.getValue(120234));
	Lua_MsgUtil.callFunc("CHAT_SHOW_ITEM_UPDATE");
end

function Lua_MingSuoPanel:onHelpClick()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(128805));
end

function Lua_MingSuoPanel:dispose()
	for i = 1, #self.modelList do
		self.modelList[i]:dispose();
		self.modelList[i] = nil;
	end
	DataCenter.mingSuoData.curFloor = nil;
	Lua_CommonUtil.removeTimer(self, self.onAddAnima);
	Lua_CommonUtil.removeTimer(self, self.onCountTimeDown);
	Lua_CommonUtil.removeTimer(self, self.onPlayAnimation);

	self:superCall("dispose");
end